
//PRIN 2000 : SISTEMI OFDM CON APPLICAZIONI ALLE RETI WLAN
//PROGETTO M U R S T
//
//
//SIMULATORE MAC VERSIONE 1.0
//
//-------------------------------------------
//PROGRAMMATORI:
//ING.GUERINO GIANCOLA kubika@libero.it                    
//ANTONELLA DE LUCA antonellad@infinito.it 
//FRANCESCO PASSI f.passi@libero.it                
//ANDREA VITALI anvit@libero.it
//-------------------------------------------
//

//LINUX: metti "abs" e "*=-1" , leva parameter.h
//VISUAL C++: viceversa


//ACCORGIMENTO GRAFICO
//MODIFICARE LA PARAMETER CON NUOVA DEFINE

#include<stddef.h>
#include<malloc.h>
#include<iostream.h>
#include<stdio.h>
#include<stdlib.h>
#include<time.h>
#include<math.h>
#include<float.h>
//#include"parameter.h"

int inutile;

//conta le trame simulate
int cont_trame=0;

#define CAPIENZA_BUFFER 800
//NUMERO DI RADIO TERMINAL CHE COLLOQUIANO CON IL RADIO NODE
#define NRT 10//30 
//NUMERO DI TIME-SLOT DI UNA TRAMA
#define NTS 6
//NUMERO DI CODICI UTILIZZATI
#define K 52 
//DURATA DEL TS
#define DURATA_TS 0.0015 // secondi
// scarto in TS tra l'emissione di una richiesta e la ricezione dell'allocazione
#define RIALLOCAZIONE 3
//IL  MASSIMO NUMERO DI TRAME E' STATO SCELTO PER AVERE UNA DURATA DI
//SIMULAZIONE PARI AD 1 ora
#define MAX_NUM_TRAME 100000 //400000

//CARATTERIZZAZIONE DEI PARAMETRI DELLE SORGENTI
#define NCLASSI 3   //numero di sottoclassi che si decide di implementare
                    // Se si cambi aquesto numero, va cambiato anche nel
                    // programma che genera i files
// PAYLOAD DELLA MAC PDU
#define PAYLOAD 78
// OVERHEAD DELLA MAC PDU
#define OVERHEAD 12
// PAYLOAD DELLA AL PDU
#define PAYLOAD_AL 72
// OVERHEAD DELLA AL PDU e' comprensivo di HEADER e di FEC(3 bytes)
#define OVERHEAD_AL 6
//POSIZIONE DEL PAGING CHANNEL NELLA MATRICE DEI CODICI
#define POSIZIONE_PAG_CH 4
//MAC PDU UTILIZZATE PER LA SEGNALAZIONE IN DL
#define SEGNALAZIONE_DL 2
// MAX RITARDO IN TS CHE IMMAGINIAMO POSSIBILE NEL SISTEMA
// IL VALORE ANDRA' TARATO IN BASE AI RISULTATI DELLE SIMULAZIONI
#define MAX_RITARDO_TS 500

#define percentuale 0.7


int BANDA_TOTALE=0;
//Capacit netta rappresenta il numero massimo  di MAC-PDU assegnabili per trama
int CAPACITA_NETTA=K*NTS-SEGNALAZIONE_DL;
//Capacita' 
int CAPACITA_ALLOCABILE_GB=(int)(ceil)(CAPACITA_NETTA*percentuale);
//Capacit totale trame rappresenta il numero massimo di MAC-PDU assegnabili per tutte le trame considerate 
//int CAPACITA_TOT_TRAME=CAPACITA_NETTA*MAX_NUM_TRAME;

double  INIZIO_ANALISI=1+MAX_NUM_TRAME*0.5; //al minimo vale 1
double  FINE_ANALISI=MAX_NUM_TRAME*0.8;


//RITARDO MASSIMO DI ACCESSO AL MEZZO
double D_MAX_ACCESSO= 2*NTS*DURATA_TS+RIALLOCAZIONE*DURATA_TS;//e' pari a 0.0225

int L_MACPDU=PAYLOAD+OVERHEAD;
int L_ALPDU=PAYLOAD_AL+OVERHEAD_AL;


// DEFINIZIONE DELLE MATRICI DELLE SORGENTI
// In queste matrici vengono inseriti i parametri
// delle sorgenti tipo che verranno utilizzate nella simulazione
// I PARAMETRI VERRANNO LETTI DAI FILE:
// sorgentitipo1.dat
// sorgentitipo2.dat
// sorgentitipo3.dat
int MATRICE_TIPO_1 [NCLASSI][5];
int MATRICE_TIPO_2 [NCLASSI][5];
int MATRICE_TIPO_3 [NCLASSI][2];
double VETTORE_RITARDI_TIPO_1[NCLASSI];
double VETTORE_RITARDI_TIPO_2[NCLASSI];

//STRUTTURA DELLA MAC-PDU
struct MAC_PDU
{
    double T_GEN;
    double NS_IP;
    double NS_MACPDU;
    int SORGENTE;
    int TIPO_TRAFFICO;
    struct MAC_PDU *NEXT_MACPDU;
};

typedef struct MAC_PDU *BUFFER;
BUFFER CODE_GB_RT[NRT];
BUFFER CODE_BE_RT[NRT];
BUFFER CODE_GB_RN[NRT];
BUFFER CODE_BE_RN[NRT];

//DEFINIAMO LA STRUTTURA DEL MINI-SLOT DEL REQUEST CHANNEL CHE VIENE MESSO
//A DISPOSIZIONE DI OGNI RADIO TERMINAL
struct RECORD_REQUEST_CHANNEL
{
	double LUNG1;
	double LUNG2;
	double BUFFER_VUOTI;
} ;

//
// DEFINIZIONE DEI CANALI DI SEGNALAZIONE
//
//DEFINIAMO LA SINGOLA MAC-PDU CHE VIENE UTILIZZATA COME PARTE DEL REQUEST CHANNEL
//QUESTA MAC-PDU CONTIENE UN CERTO NUMERO DEI MINI-SLOT DEFINITI PRIMA
//DEFINIAMO, IN SOSTANZA, UN VETTORE DI MINI-SLOT
struct RECORD_REQUEST_CHANNEL REQUEST_CHANNEL[NRT];
// LA STESSA STRUTTURA DEL REQUEST CHANNEL VIENE GESTITA DAL RADIO NODE
struct RECORD_REQUEST_CHANNEL STATO_CODE_AL_RN[NRT];
//
// DEFINIAMO ADESSO I DUE CANALI CHE UTILIZZA IL RADIO NODE
// NEL DOWNLINK: L'ALLOCATIONAL_CHANNEL E IL PAGING_CHANNEL
// entrambi questi due canali sono individuati da una matrice bidimensionale
// che ha per righe i RADIO TERMINALs e per colonne i TIME SLOTs
// ogni elemento della matrice e' un puntatore alla CODA DEI CODICI
// LA CODA DEI CODICI RAPPRESENTA L'INSIEME DEI CODICI ASSEGNATI O DA ASCOLTARE
// PER UN RADIO TERMINAL E PER UN TIME SLOT
//
/*struct CODE
{
 int COD;
 struct CODE *NEXT_COD;
};
typedef struct CODE *pCODE;
pCODE PAGING_CHANNEL[NRT][NTS];
pCODE ALLOCATIONAL_CHANNEL[NRT][NTS];
// definendo cosi' l'ALLOCATIONAL_CHANNEL prevedo un CDMA-TDMA pure per l'uplink.
// per implementare un TDMA in uplink l'ALLOCATIONAL_CHANNEL sarebbe un vettore di
// puntatori che elenca per ogni RT i TS assegnati.
*/

// DEFINIZIONE DELLE STRUTTURE PER LA GENERAZIONE DELL'OUTPUT
// QUESTE STRUTTURE PERMETTONO DI VALUTARE LE PRESTAZIONI DEL MAC
//
// Contatori delle MACPDU che partono dai RADIO TERMINAL verso il RADIO NODE
int CONT_MACPDU_GB_RT[NRT];
int CONT_MACPDU_BE_RT[NRT];
// Contatori delle MACPDU che partono dal RADIO NODE verso i RADIO TERMINAL
int CONT_MACPDU_GB_RN[NRT];
int CONT_MACPDU_BE_RN[NRT];
// Contatori dei pacchetti IPche partono dai RADIO TERMINAL verso il RADIO NODE
int CONT_IP_GB_RT[NRT];
int CONT_IP_BE_RT[NRT];
// Contatori dei pacchetti IP che partono dal RADIO NODE verso i RADIO TERMINAL
int CONT_IP_GB_RN[NRT];
int CONT_IP_BE_RN[NRT];
//Contiene il numero di MACPDU nella coda BE per ogni RT di destinazione
int LUNGHEZZA_CODE_BE[NRT];
int OVERFLOW_BE_HAPPENED[NRT];
// DEFINIAMO ADESSO LE STRUTTURE CHE UTILIZZIAMO PER DESCRIVERE LE SORGENTI
// DI TRAFFICO (CHE POSSONO ESSERE DI 3 TIPI)
// TIPO 1: SORGENTI ON-OFF (CLASSE GB)
// TIPO 2: SORGENTI CBR (CLASSE GB)
// TIPO 3: SORGENTI POISSONIANE (CLASSE BE)

// STRUTTURA PER SORGENTI DI TIPO 1 (ON-OFF CLASSE GB)
// queste sorgenti vengono caratterizzate dai seguenti parametri:
// T_ON : durata fissa dell'attivita' della sorgente
// T_OFF : durata fissa del silenzio della sorgente
// RATE_PICCO : ritmo di picco (byte/sec)
// RATE_MEDIO : ritmo medio sostenibile o token rate (byte/sec)
// TBD : token buffer dimension - tolleranza di burst (byte)
// L_IP : lunghezza pacchetto IP (byte)
// BYTE : contatore BYTE emessi
// IDENTIFICATIVO : numero che caratterizza la sorgente nel radio terminal
// BANDA_MAC : numero di MAC-PDU che dobbiamo garantire per trama
// D_MAX : ritardo massimo in secondi ammesso per un pacchetto IP
// TNEXT : tempo di generazione prossimo pacchetto
// PRIMO_MOMENTO : accumula i ritardi subiti dalle MAC_PDU
// SECONDO MOMENTO : accumula i quadrati dei ritardi subiti dalle MAC_PDU
struct SORGENTE_TIPO1
{
       double T_ON;
       double T_OFF;
       int RATE_PICCO;
       int RATE_MEDIO;
       int TBD;
       int L_IP;
       int BYTE;
       int IDENTIFICATIVO;
       int BANDA_MAC;
       double D_MAX;
       double TNEXT;
       double PRIMO_MOMENTO;
       double SECONDO_MOMENTO;
       struct SORGENTE_TIPO1 *NEXT_SORG;
};

// STRUTTURA PER SORGENTI DI TIPO 2 (CBR CLASSE GB)
// queste sorgenti vengono caratterizzate dai seguenti parametri:
// RATE_PICCO : ritmo di picco (byte/sec)
// RATE_MEDIO : ritmo medio sostenibile o token rate (byte/sec)
// TBD : token buffer dimension - tolleranza di burst (byte)
// L_IP : lunghezza pacchetto IP (byte)
// IDENTIFICATIVO : numero che caratterizza la sorgente nel radio terminal
// BANDA_MAC : numero di MAC-PDU che dobbiamo garantire per trama
// D_MAX : ritardo massimo in secondi ammesso per un pacchetto IP
// BYTE : contatore BYTE emessi
// TNEXT : tempo di generazione prossimo pacchetto
// PRIMO_MOMENTO : accumula i ritardi subiti dalle MAC_PDU
// SECONDO MOMENTO : accumula i quadrati dei ritardi subiti dalle MAC_PDU
struct SORGENTE_TIPO2
{
       int RATE_PICCO;
       int RATE_MEDIO;
       int TBD;
       int L_IP;
       int IDENTIFICATIVO;
       int BANDA_MAC;
       double D_MAX;
       double TNEXT;
       double PRIMO_MOMENTO;
       double SECONDO_MOMENTO;
       struct SORGENTE_TIPO2 *NEXT_SORG;
};


// STRUTTURA PER SORGENTI DI TIPO 3 (VBR CLASSE BE)
// queste sorgenti vengono caratterizzate dai seguenti parametri:
// FREQUENZA_MEDIA : frequenza media di interarrivo dei pacchetti IP
// L_IP : lunghezza pacchetto IP (byte)
// BYTE : contatore BYTE emessi
// TNEXT : tempo di generazione prossimo pacchetto
// PRIMO_MOMENTO : accumula i ritardi subiti dalle MAC_PDU
// SECONDO MOMENTO : accumula i quadrati dei ritardi subiti dalle MAC_PDU 
struct SORGENTE_TIPO3
{
    int FREQUENZA_MEDIA;
    int L_IP;
    int IDENTIFICATIVO;
    double TNEXT;
    double PRIMO_MOMENTO;
    double SECONDO_MOMENTO;
    struct SORGENTE_TIPO3 *NEXT_SORG;
};

// VETTORI DI INTERI CHE RACCOLGONO PER OGNI RADIO TERMINAL LA BANDA GARANTITA
// DELLE SUE SORGENTI GB
int BANDE_TOTALI_MAC_UL[NRT];
int BANDE_TOTALI_MAC_DL[NRT];


// DEFINIAMO I PUNTATORI ALLE STRUTTURE DI SORGENTI
typedef struct SORGENTE_TIPO1 *pTIPO_1;
typedef struct SORGENTE_TIPO2 *pTIPO_2;
typedef struct SORGENTE_TIPO3 *pTIPO_3;

struct SORG_123
{
        pTIPO_1  T1;
        pTIPO_2  T2;
        pTIPO_3  T3;
        int S_ID;
};

// VETTORI CHE RACCOLGONO LE SORGENTI
// OGNI ELEMENTO DEI VETTORE CORRISPONDE AD UN RADIO TERMINAL
struct SORG_123 VETTORE_SORGENTI_RT_UL[NRT];
struct SORG_123 VETTORE_SORGENTI_RT_DL[NRT];



// ISTOGRAMMA DEI RITARDI DELLE MAC PDU PER TUTTO IL TRAFFICO IP* AL RT
// *DIFFERENZA NS TRAFFICO BE RISPETTO A DELLUOMO
//Hyst delay rappresenta quante volte si  verificato un certo numero di TS di ritardo
int hyst_delay_BE[NRT][MAX_RITARDO_TS+1];
//Normalizza delay BE  numero totale di MAC-PDU BE che sono state trasmesse verso quel RT 
int normalizza_delay_BE[NRT]; 
int normalizza_delay_ON_OFF[NRT];
int normalizza_delay_CBR[NRT];


//Il riempimento dei buffer  su base TS.
//ISTOGRAMMA DEL RIEMPIMENTO DEL BUFFER GB PER CIASCUN RT
//Hyst riempimento rappresenta quante volte c' stato quel numero di MAC-PDU in quel TIME-SLOT
int hyst_riempimento_GB[NRT][CAPIENZA_BUFFER+2];

//ISTOGRAMMA DEL RIEMPIMENTO DEL BUFFER BE PER CIASCUN RT
int hyst_riempimento_BE[NRT][CAPIENZA_BUFFER+2];



//Gli istogrammi sono  su base trama, dove la trama  quella che inizia dal PAGING CHANNEL,mentre nel file matrice dei //codici  rappresentata la matrice dei codici.Quindi nel conteggio della portata bisogna considerare i TS 0,1,2,3 
//della matrice dei codici corrente e i TS 4,5 della matrice dei codici precedente a quella corrente.
//Hyst portata rappresenta quante MAC-PDU sono state assegnate in quella trama

int hyst_portata_ON_OFF[NRT][NTS*K-SEGNALAZIONE_DL+1];
int hyst_portata_CBR[NRT][NTS*K-SEGNALAZIONE_DL+1]; //Dovrebbe venire un DIRAC
int hyst_portata_GB[NRT][NTS*K-SEGNALAZIONE_DL+1];
int hyst_portata_BE[NRT][NTS*K-SEGNALAZIONE_DL+1];


//Hyst codice probabile rappresenta quante volte un certo codice  assegnato al particolare RT	
int hyst_CODICE_PROBABILE_GB[NRT][K];
// Normalizza Cod_Probabile conta quanti codici in totale sono stati assegnati per ogni RT, per la classe GB 
int normalizza_COD_PROBABILE_GB[NRT];
int hyst_CODICE_PROBABILE_BE[NRT][K];
// Normalizza Cod_Probabile conta quanti codici in totale sono stati assegnati per ogni RT, per la classe BE 
int normalizza_COD_PROBABILE_BE[NRT];

 struct DELAY_MM
 {
    double MIN;
    double MAX;
 };


struct  DELAY_MM DELAY_ON_OFF[NRT];
struct  DELAY_MM DELAY_CBR[NRT];
struct  DELAY_MM DELAY_BE[NRT];



///////////////////////////////
// P R O C E D U R E //////////
///////////////////////////////


/// PROCEDURE AUSILIARIE

//SE COMPILI CON UN COMPILATORE "C" TI PUO' DARE ERRORE PERCHE' ESISTE UNA FUNZIONE CON QUESTO NOME:
//TI CONVIENE CAMBIARE NOME
double max (double a,double b)
{
 if (a>=b) return(a);
 else    return(b);
}


int massimo (int a,int b)
{
 if (a>=b) return(a);
 else    return(b);
}

//SE COMPILI CON UN COMPILATORE "C" TI PUO' DARE ERRORE PERCHE' ESISTE UNA FUNZIONE CON QUESTO NOME:
//TI CONVIENE CAMBIARE NOME
double min (double a,double b)
{
 if (a<=b) return(a);
 else    return(b);
}


int minimo (int a,int b)
{
 if (a<=b) return(a);
 else    return(b);
}

// PROCEDURA DI RIEMPIMENTO DELLE MATRICI DELLE SORGENTI
void CREA_MATRICI_SORGENTI()
{
FILE *fp1,*fp2,*fp3;
int j,c,temp;
double dtemp;
fp1=fopen("sorgentitipo1.dat","r");
fp2=fopen("sorgentitipo2.dat","r");
fp3=fopen("sorgentitipo3.dat","r");
// matrice sorgenti di tipo 1
for (j=0;j<NCLASSI;j++)
    {
    for (c=0;c<4;c++)
        {
        fscanf(fp1,"%d",&temp);
        MATRICE_TIPO_1[j][c]=temp;
        }
    fscanf(fp1,"%lf",&dtemp);
    VETTORE_RITARDI_TIPO_1[j]=dtemp;
    }
fclose(fp1);
// matrice sorgenti di tipo 2
for (j=0;j<NCLASSI;j++)
    {
    for (c=0;c<4;c++)
        {
        fscanf(fp2,"%d",&temp);
        MATRICE_TIPO_2[j][c]=temp;
        }
    fscanf(fp2,"%lf",&dtemp);
    VETTORE_RITARDI_TIPO_2[j]=dtemp;
    }
fclose(fp2);
// matrice sorgenti di tipo 3
for (j=0;j<NCLASSI;j++)
    {
    for (c=0;c<2;c++)
        {
        fscanf(fp3,"%d",&temp);
        MATRICE_TIPO_3[j][c]=temp;
        }
    }
fclose(fp3);
return;
}



//PROCEDURA DI INIZIALIZZAZIONE DEL REQUEST CHANNEL
void inizializzazione_REQUEST_CHANNEL()
{
	int i;
	for(i=0;i<NRT;i++)
	{

        REQUEST_CHANNEL[i].LUNG1=0;
        REQUEST_CHANNEL[i].LUNG2=0;
        REQUEST_CHANNEL[i].BUFFER_VUOTI=0;
        //IL REQUEST CHANNEL E' POSTO TUTTO A ZERO
        //NON C'E' NESSUNA RICHIESTA DA PARTE DI NESSUN RADIO TERMINAL

	}
	//printf("\nStruttura del REQUEST CHANNEL inizializzata \n");*****
	return;
}

void inizializzazione_STATO_CODE_AL_RN()
//funzione di inizializzazione dell'analogo del ReqCh
//in DL
{
	int i;
     for(i=0;i<NRT;i++)
	{
        STATO_CODE_AL_RN[i].LUNG1=0;
        STATO_CODE_AL_RN[i].LUNG2=0;
        STATO_CODE_AL_RN[i].BUFFER_VUOTI=0;
	}	
     //ho inizializzato tutto il stato_code_al_RN a 0
     //printf("\nStruttura del 'stato_code_al_RN' inizializzata \n");
	return;
 }

//PROCEDURA DI INIZIALIZZAZIONE DELl' ALLOCATIONAL CHANNEL
/*void inizializzazione_ALLOCATIONAL_CHANNEL()
{
     int i,j;
     for (i=0;i<NRT;i++)
     {
       for (j=0;j<NTS;j++)
         {
         ALLOCATIONAL_CHANNEL[i][j]=NULL;
         }
     }
     printf("\nStruttura dell'ALLOCATIONAL CHANNEL inizializzata \n");
     return;
}

*/
//PROCEDURA DI INIZIALIZZAZIONE DEL PAGING CHANNEL
/*void inizializzazione_PAGING_CHANNEL()
{
     int i,j;
     for (i=0;i<NRT;i++)
     {
      for (j=0;j<NTS;j++)
        {
         PAGING_CHANNEL[i][j]=NULL;
        }
      }
printf("\nStruttura del PAGING CHANNEL inizializzata\n");
     return;
}
*/


int INIZIO_ROUND_ROBIN_GB,INIZIO_ROUND_ROBIN_BE;
//SINGOLO ELEMENTO DELLA MATRICE DEI CODICI
struct TC_PAIR
{ 
	int TIPO;
    int RT;
};

//MATRICE DEI CODICI
struct TC_PAIR MATRICE_CODICI[K][NTS];


//PROCEDURA DI INIZIALIZZAZIONE DELLA MATRICE DEI CODICI
void inizializzazione_MATRICE_CODICI()
{
	int i,j;
	//i e j contano rispettivamente i CODICI ed i TIME-SLOT
    for (i=0;i<K;i++)
	{
		for (j=0;j<NTS;j++)
		{
			MATRICE_CODICI[i][j].RT=-1;
			MATRICE_CODICI[i][j].TIPO=-1;

		}
	}
	// Inizializzo entrambe i campi della matrice dei codici a -1
    j=POSIZIONE_PAG_CH;
	for (i=0;i<SEGNALAZIONE_DL;i++)
	{
	   MATRICE_CODICI[i][j].RT=-2;
       MATRICE_CODICI[i][j].TIPO=-2;

	}
	// Riinizializzo la parte della matrice dei codici relativa
	//alla segnalazione a -2
// printf("\nStruttura della matrice dei codici inizializzata\n");
return;
}


// INIZIALIZZAZIONE BUFFER

void inizializza_BUFFER()
{
int temp;
for (temp=0;temp<NRT;temp++)
         {
         CODE_GB_RT[temp]=NULL;
         CODE_BE_RT[temp]=NULL;
         CODE_GB_RN[temp]=NULL;
         CODE_BE_RN[temp]=NULL;
         
         LUNGHEZZA_CODE_BE[temp]=0;
         OVERFLOW_BE_HAPPENED[temp]=0;
         }
//printf("\nBuffer inizializzati \n");
return;

}

void inizializza_CONTATORI()
{
int temp;
for (temp=0;temp<NRT;temp++)
        {
        CONT_MACPDU_GB_RT[temp]=0;
        CONT_MACPDU_BE_RT[temp]=0;
        CONT_MACPDU_GB_RN[temp]=0;
        CONT_MACPDU_BE_RN[temp]=0;
        CONT_IP_GB_RT[temp]=0;
        CONT_IP_BE_RT[temp]=0;
        CONT_IP_GB_RN[temp]=0;
        CONT_IP_BE_RN[temp]=0;
        }
//printf("\nContatori inizializzati \n");
return;
}

// METTE A ZERO I VETTORI CHE CONTENGONO LA BANDA GARANTITA TOTALE PER RT
void inizializza_BANDE_TOTALI_MAC()
{
int i;
for (i=0;i<NRT;i++)
    {
    BANDE_TOTALI_MAC_UL[i]=0;
    BANDE_TOTALI_MAC_DL[i]=0;
    }
//printf("\nBande totali MAC inizializzate \n\n\n");
return;
}


// PROCEDURE DI GESTIONE DELL'ALLOCATIONAL E DEL PAGING CHANNEL
// tutte queste procedure ricevono come ingresso, necessariamente,
// la matrice su cui devono essere applicate

/*void AGGIUNGI_RISORSA(pCODE MATRIX[NRT][NTS],int k,int RT,int TS)  
{
pCODE support;
if (MATRIX[RT][TS]==NULL)
   {
   MATRIX[RT][TS]=(pCODE)malloc(sizeof(CODE));
   support=MATRIX[RT][TS];
   }
   else
   {
   support=MATRIX[RT][TS];
   while (support->NEXT_COD!=NULL) support=support->NEXT_COD;
   support->NEXT_COD=(pCODE)malloc(sizeof(CODE));
   support=support->NEXT_COD;
   }
support->COD=k;
support->NEXT_COD=NULL;
return;
}


// NON USATA: COSTRUISCO IL PAGING CHANNEL ON THE FLY CIOE' AL MOMENTO
// DEL RIEMPIMENTO DELLA MATRICE DEI CODICI
void costruisci_PAGING_CHANNEL(int RT)
{
int i,j,temp;
  for (i=0;i<K;i++)
  {
	  for (j=0;j<NTS;j++)
	  {
       if (((MATRICE_CODICI[i][j].RT)!=-2)&&((MATRICE_CODICI[i][j].RT)!=-1))
       {
	   AGGIUNGI_RISORSA(PAGING_CHANNEL,i,RT,j);
       }
	  }
  }
 return;
}
*/


/*void DEALLOCA_RISORSE(pCODE MATRIX[][NTS])
{
pCODE support1,support2;
int a,b;
for (a=0;a<NRT;a++)
    {
    for (b=0;b<NTS;b++)
        {
        support1=MATRIX[a][b];
        while (support1!=NULL)
              {
              support2=support1->NEXT_COD;
              free(support1);
              support1=support2;
              }
        MATRIX[a][b]=NULL;
        }
    }
return;
}



int CONTA_e_DEALLOCA(pCODE MATRIX[][NTS],int RT,int TS)
// questa procedura conta le risorse (codici) allocati per un dato
// radio terminal e per un dato Time Slot. La procedura restituisce come
// risultato il numero di risorse allocate e resetta a zero quell'elemento
// dell'array preso in considerazione
{
int contarisorse=0;
pCODE support1,support2;
support1=MATRIX[RT-1][TS-1];
if (support1!=NULL)
    while (support1!=NULL)
    {
    contarisorse++;
    support2=support1->NEXT_COD;
    free(support1);
    support1=support2;
    }
return contarisorse;
}



int CONTA(pCODE MATRIX[][NTS],int RT,int TS)
// come prima ma senza deallocazione della memoria
{
int contarisorse=0;
pCODE support1;
support1=MATRIX[RT-1][TS-1];
if (support1!=NULL)
    while (support1!=NULL)
    {
    contarisorse++;
    support1=support1->NEXT_COD;
    }
return contarisorse;
}
*/

// PROCEDURE DI INIZIALIZZAZIONE DEI VETTORI CHE RACCOLGONO LE SORGENTI

void inizializza_SORGENTI_DL()
{
     int i;
     for (i=0;i<NRT;i++)
     {
            VETTORE_SORGENTI_RT_DL[i].T1=NULL;
            VETTORE_SORGENTI_RT_DL[i].T2=NULL;
            VETTORE_SORGENTI_RT_DL[i].T3=NULL;
            VETTORE_SORGENTI_RT_DL[i].S_ID=0;
     }
     //printf("\nSorgenti DL inizializzate\n");
     return;
}

int  assegnazione_banda_DL_TIPO1(int i,int temp)  //"i" indica il RT  
{
double B_MAC,B_RSVP,NUM_BW,BW;         // [bytes/sec]
// la banda RSVP non rimane memorizzata nella sorgente ma serve solamente
// per arrivare a calcolare la banda MAC

         //ASSEGNO LE BANDE ALLE SORGENTI ON-OFF
         
NUM_BW=(double)((MATRICE_TIPO_1[temp-1][0])*(MATRICE_TIPO_1[temp-1][2])); //NUMERATORE PER IL CALCOLO DELLA BANDA
BW=NUM_BW/(double)(((MATRICE_TIPO_1[temp-1][0]-MATRICE_TIPO_1[temp-1][1])*(VETTORE_RITARDI_TIPO_1[temp-1]-D_MAX_ACCESSO))+(MATRICE_TIPO_1[temp-1][2]));

B_RSVP=max(BW,(double)MATRICE_TIPO_1[temp-1][1]);
// Calcolo della banda RSVP secondo l'articolo di WHITE

B_MAC=B_RSVP*(ceil(MATRICE_TIPO_1[temp-1][3]/(double)PAYLOAD_AL))*(L_MACPDU/(double)MATRICE_TIPO_1[temp-1][3]);
// Calcolo la banda allo strato MAC al netto dell'overhead di strato MAC e AL

return (int)ceil(B_MAC*(NTS*DURATA_TS)/(double)L_MACPDU);
 
}               
         
               
int  assegnazione_banda_DL_TIPO2(int i,int temp)  //"i" indica il RT  
{
double B_MAC,B_RSVP,NUM_BW,BW;         // [bytes/sec]
// la banda RSVP non rimane memorizzata nella sorgente ma serve solamente
// per arrivare a calcolare la banda MAC               
               
               
//ASSEGNO LE BANDE ALLE SORGENTI CBR

B_RSVP=(double)(MATRICE_TIPO_2[temp-1][0]);
// Calcolo della banda RSVP secondo l'articolo di WHITE
B_MAC=B_RSVP*(ceil(MATRICE_TIPO_2[temp-1][3]/(double)PAYLOAD_AL))*(L_MACPDU/(double)MATRICE_TIPO_2[temp-1][3]);
// Calcolo la banda allo strato MAC al netto dell'overhead di strato MAC e AL

return (int)ceil((B_MAC*NTS*DURATA_TS)/(double)L_MACPDU);

}


// PROCEDURE DI INSERIMENTO DI UNA NUOVA SORGENTE AL RADIO NODE
int inserisci_sorgente_TIPO1_RN(int T,int temp)
{
pTIPO_1 support;
int BW_MAC=0;
BW_MAC=assegnazione_banda_DL_TIPO1(T-1,temp);

if ((BANDA_TOTALE+BW_MAC)<= CAPACITA_ALLOCABILE_GB)
{

VETTORE_SORGENTI_RT_DL[T-1].S_ID+=1;
support=VETTORE_SORGENTI_RT_DL[T-1].T1;

//printf("Questa e' l'inserisci sorgente tipo1");*****
 if (support==NULL)
   {              // E' la prima sorgente di quel tipo per quel radio-terminal
   VETTORE_SORGENTI_RT_DL[T-1].T1=(pTIPO_1)malloc(sizeof(struct SORGENTE_TIPO1));
   support=VETTORE_SORGENTI_RT_DL[T-1].T1;
   
   support->T_ON=(MATRICE_TIPO_1[temp-1][2])/(double)((MATRICE_TIPO_1[temp-1][0])-(MATRICE_TIPO_1[temp-1][1]));
  // printf("\nT_ON e' %lf\n",support->T_ON);*****
   support->T_OFF=(MATRICE_TIPO_1[temp-1][2])/(double)(MATRICE_TIPO_1[temp-1][1]);
   //printf("\nT_OFF e' %lf\n",support->T_OFF);*****
   support->RATE_PICCO=MATRICE_TIPO_1[temp-1][0];
  // printf("\nRATE_PICCO e' %d\n",support->RATE_PICCO);*****
   support->RATE_MEDIO=MATRICE_TIPO_1[temp-1][1];
   //printf("\nRATE_MEDIO e' %d\n",support->RATE_MEDIO);*****
   support->TBD=MATRICE_TIPO_1[temp-1][2];
   //printf("\nTBD e' pari a %d\n",support->TBD);*****
   support->L_IP=MATRICE_TIPO_1[temp-1][3];
   //printf("\nL_IP e' %d\n",support->L_IP);*****
   support->BYTE=0;
  // printf("\nBYTE e' %d\n",support->BYTE);*****

   support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_DL[T-1].S_ID;
   support->D_MAX=VETTORE_RITARDI_TIPO_1[temp-1];
   support->BANDA_MAC=BW_MAC;
   
   support->TNEXT=0;
   support->PRIMO_MOMENTO=0;
   support->SECONDO_MOMENTO=0;
   support->NEXT_SORG=NULL;
   
   BANDE_TOTALI_MAC_DL[T-1]+=support->BANDA_MAC;
   printf("\nB_MAC tipo 1 assegnata al RT %d e' %d %\n",T,support->BANDA_MAC);

   // support punta al record della nuova sorgente
   }
else              // Non e' la prima sorgente di quel tipo per quel radio-terminal
    {
    while (support->NEXT_SORG!=NULL) support=support->NEXT_SORG;
    support->NEXT_SORG=(pTIPO_1)malloc(sizeof(struct SORGENTE_TIPO1));
    support=support->NEXT_SORG;
    
    support->T_ON=(MATRICE_TIPO_1[temp-1][2])/(double)((MATRICE_TIPO_1[temp-1][0])-(MATRICE_TIPO_1[temp-1][1]));
    support->T_OFF=(MATRICE_TIPO_1[temp-1][2])/(double)(MATRICE_TIPO_1[temp-1][1]);
    support->RATE_PICCO=MATRICE_TIPO_1[temp-1][0];
    support->RATE_MEDIO=MATRICE_TIPO_1[temp-1][1];
    support->TBD=MATRICE_TIPO_1[temp-1][2];
    support->L_IP=MATRICE_TIPO_1[temp-1][3];
    support->BYTE=0;
    support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_DL[T-1].S_ID;
    support->D_MAX=VETTORE_RITARDI_TIPO_1[temp-1];
    support->BANDA_MAC=BW_MAC;
    support->TNEXT=0;
    support->PRIMO_MOMENTO=0;
    support->SECONDO_MOMENTO=0;
    support->NEXT_SORG=NULL;
    
    BANDE_TOTALI_MAC_DL[T-1]+=support->BANDA_MAC;
    printf("\nB_MAC tipo 1 assegnata al RT %d e' %d %\n",T,support->BANDA_MAC);
    // support punta al record della nuova sorgente
    }
return (support->BANDA_MAC);
}
else return 0;

}


int inserisci_sorgente_TIPO2_RN(int T,int temp)
{
pTIPO_2 support;

int BW_MAC=0;
BW_MAC=assegnazione_banda_DL_TIPO2(T-1,temp);

if ((BANDA_TOTALE+BW_MAC)<=CAPACITA_ALLOCABILE_GB)
   {

   VETTORE_SORGENTI_RT_DL[T-1].S_ID+=1;
   support=VETTORE_SORGENTI_RT_DL[T-1].T2;
   if (support==NULL)
       {              // E' la prima sorgente di quel tipo per quel radio-terminal
        VETTORE_SORGENTI_RT_DL[T-1].T2=(pTIPO_2)malloc(sizeof(struct SORGENTE_TIPO2));
        support=VETTORE_SORGENTI_RT_DL[T-1].T2;
        support->RATE_PICCO=MATRICE_TIPO_2[temp-1][0];
        support->RATE_MEDIO=MATRICE_TIPO_2[temp-1][1];
        support->TBD=MATRICE_TIPO_2[temp-1][2];
        support->L_IP=MATRICE_TIPO_2[temp-1][3];
        support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_DL[T-1].S_ID;
        support->D_MAX=VETTORE_RITARDI_TIPO_2[temp-1];
        support->BANDA_MAC=BW_MAC;
        support->TNEXT=0;
        support->PRIMO_MOMENTO=0;
        support->SECONDO_MOMENTO=0;
        support->NEXT_SORG=NULL;
        BANDE_TOTALI_MAC_DL[T-1]+=support->BANDA_MAC;
        printf("\nB_MAC tipo 2 assegnata al RT %d e' %d %\n",T,support->BANDA_MAC);
        
        // support punta al record della nuova sorgente
       }
   else              // Non e' la prima sorgente di quel tipo per quel radio-terminal
       {
      	while (support->NEXT_SORG!=NULL) support=support->NEXT_SORG;
        support->NEXT_SORG=(pTIPO_2)malloc(sizeof(struct SORGENTE_TIPO2));
        support=support->NEXT_SORG;
        support->RATE_PICCO=MATRICE_TIPO_2[temp-1][0];
        support->RATE_MEDIO=MATRICE_TIPO_2[temp-1][1];
        support->TBD=MATRICE_TIPO_2[temp-1][2];
        support->L_IP=MATRICE_TIPO_2[temp-1][3];
        support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_DL[T-1].S_ID;
        support->D_MAX=VETTORE_RITARDI_TIPO_2[temp-1];
        support->BANDA_MAC=BW_MAC;
        support->TNEXT=0;
        support->PRIMO_MOMENTO=0;
        support->SECONDO_MOMENTO=0;
        support->NEXT_SORG=NULL;
        BANDE_TOTALI_MAC_DL[T-1]+=support->BANDA_MAC;
        printf("\nB_MAC tipo 2 assegnata al RT %d e' %d %\n",T,support->BANDA_MAC);
        // support punta al record della nuova sorgente
        }
   return (support->BANDA_MAC);
   
   }
else return 0;
}

void inserisci_sorgente_TIPO3_RN(int T,int temp)
{
pTIPO_3 support;
VETTORE_SORGENTI_RT_DL[T-1].S_ID+=1;
support=VETTORE_SORGENTI_RT_DL[T-1].T3;
if (support==NULL)
   {              // E' la prima sorgente di quel tipo per quel radio-terminal
   VETTORE_SORGENTI_RT_DL[T-1].T3=(pTIPO_3)malloc(sizeof(struct SORGENTE_TIPO3));
   //printf("\nRT= %d\n",T);
   support=VETTORE_SORGENTI_RT_DL[T-1].T3;
   support->FREQUENZA_MEDIA=MATRICE_TIPO_3[temp-1][0];
   //printf("\nFrequenza media= %d\n",support->FREQUENZA_MEDIA);
   support->L_IP=MATRICE_TIPO_3[temp-1][1];
   //printf("\nL_IP= %d\n",support->L_IP);
   support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_DL[T-1].S_ID;
   support->PRIMO_MOMENTO=0;
   support->SECONDO_MOMENTO=0;
   support->NEXT_SORG=NULL;
   // support punta al record della nuova sorgente
   }
else              // Non e' la prima sorgente di quel tipo per quel radio-terminal
    {
    while (support->NEXT_SORG!=NULL) support=support->NEXT_SORG;
    //printf("\nRT= %d\n",T);
    support->NEXT_SORG=(pTIPO_3)malloc(sizeof(struct SORGENTE_TIPO3));
    support=support->NEXT_SORG;
    support->FREQUENZA_MEDIA=MATRICE_TIPO_3[temp-1][0];
    //printf("\nFrequenza media= %d\n",support->FREQUENZA_MEDIA);
    support->L_IP=MATRICE_TIPO_3[temp-1][1];
    //printf("\nL_IP= %d\n",support->L_IP);
    support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_DL[T-1].S_ID;
    support->PRIMO_MOMENTO=0;
    support->SECONDO_MOMENTO=0;
    support->NEXT_SORG=NULL;
    // support punta al record della nuova sorgente
    }
return;
}

// PROCEDURA CHE CONTA LE SORGENTI INSERITE AL RADIO NODE
void CONTA_SORGENTI_RN()
{
int contaRT,contasorgenti1=0,contasorgenti2=0,contasorgenti3=0,VERIFICA=0;
pTIPO_1 support1;
pTIPO_2 support2;
pTIPO_3 support3;
for (contaRT=0;contaRT<NRT;contaRT++)
    {
    VERIFICA+=VETTORE_SORGENTI_RT_DL[contaRT].S_ID;
    support1=VETTORE_SORGENTI_RT_DL[contaRT].T1;
    while (support1!=NULL)
          {
          contasorgenti1++;
          support1=support1->NEXT_SORG;
          }
    support2=VETTORE_SORGENTI_RT_DL[contaRT].T2;
    while (support2!=NULL)
          {
          contasorgenti2++;
          support2=support2->NEXT_SORG;
          }
    support3=VETTORE_SORGENTI_RT_DL[contaRT].T3;
    while (support3!=NULL)
          {
          contasorgenti3++;
          support3=support3->NEXT_SORG;
          }
    }
    printf("\n\n----------------------------------------------------");
    printf("\nAL RADIO NODE SONO PRESENTI COMPLESSIVAMENTE:\n");
    printf("\n%d SORGENTI ON-OFF (TIPO 1)",contasorgenti1);
    printf("\n%d SORGENTI CBR (TIPO 2)",contasorgenti2);
    printf("\n%d SORGENTI BEST EFFORT (TIPO 3)",contasorgenti3);
    printf("\n%d SORGENTI TOTALI",VERIFICA);
    printf("\n----------------------------------------------------\n");
return;
}



//RESTITUISCE UN INTERO UNIFORMEMENTE DISTRIBUITO FRA "0" e "a-1"
/*int random_int(int a)
{
 double casual;
 int stocastic;
 casual=rand()/(double)(casual/(RAND_MAX+1));
 casual=casual*(a+1);
 if (casual==0) casual=1;
 //gestione del caso in cui il numero casuale risulti pari a 0
 casual-=1;
 stocastic=(int)ceil(casual);
 return (stocastic);
}
*/


//RESTITUISCE UN INTERO UNIFORMEMENTE DISTRIBUITO FRA "0" e "a-1"
int random_int(int a)
{
int casual;
casual=(abs)((int)ceil((rand()/(double)(RAND_MAX))*a));
//casual=(int)ceil((rand()/(double)(RAND_MAX+1))*a);
//ANDREA HA AVUTO OVERFLOW UTILIZZANDO QUESTA SECONDA ISTRUZIONE

if (casual==0) casual=1;
//gestione del caso in cui il numero casuale risulti pari a 0
return (casual-1);
}

/*//RESTITUISCE UN INTERO UNIFORMEMENTE DISTRIBUITO FRA "0" e "a-1"
int random_int(int a)
{
	int casual,stime;

	long ltime;
	ltime=time(NULL);
	stime=(unsigned int)ltime/2;
	srand(stime);
	casual=(int)ceil((rand()/double(RAND_MAX+1))*a);
    return(casual-1);
}
*/

//RESTITUISCE UN REALE UNIFORMEMENTE DISTRIBUITO FRA "0" e "a"

double random_real(double a)
{
	double casual;
	casual=(rand()/double(RAND_MAX+1));
	casual=casual*a;
        if (casual<0) casual*=-1;
    return(casual);
}


// INIZIALIZZAZIONE DELLE SORGENTI ON-OFF
// viene passato il vettore di sorgenti interessato e l'indicatore del RT
void inizializza_sorgenti_TIPO1(int RT)
{
pTIPO_1 p=VETTORE_SORGENTI_RT_DL[RT].T1;
double casuale;
int temp;
//printf("\nInizializzo il traffico delle sorgenti di TIPO 1 verso il RT %d \n",RT+1);
//scanf("%d",&inutile);
	while (p!=NULL)
      {
         // generazione numero random tra 0 compreso e 1 escluso
         casuale=random_real(1);//(double)rand()/(RAND_MAX+1);
         //printf("\ncasuale e' pari a %lf\n",casuale);*****
        // printf("\nT_ON e' pari a %f\n",p->T_ON);*****
        // printf("\nT_OFF e' pari a %f\n",p->T_OFF);*****

         // normalizzazione tra T_ON e T_OFF
         casuale=casuale*((p->T_ON)+(p->T_OFF));
         //printf("\ncasuale e' pari a %lf\n",casuale);*****
         // adesso 'casuale' simula se ci troviamo in un periodo di ON o di OFF
         if (casuale<p->T_ON)       // periodo di ON
            {
            temp=(int)ceil((p->RATE_PICCO)*casuale);
            //printf("\nRate Picco e' pari a %d\n", p->RATE_PICCO);*****
            p->BYTE=temp;
            //printf("\nBYTE e' pari a %d\n\n",p->BYTE);*****
            //scanf("%d",&inutile);
            p->TNEXT=0;
            }
         else                       // periodo di OFF
            {
            p->BYTE=0;
            //printf("\nBYTE e' pari a %d\n\n",p->BYTE);*****
            //scanf("%d",&inutile);
            p->TNEXT=(p->T_ON)+(p->T_OFF)-casuale;
            }
		 if (RT==1)
		 {
			 p->TNEXT=(p->T_ON+p->T_OFF)/2;
		    // printf("\nModifica forzata di tnext  pari a %lf\n",p->TNEXT);***** 
		     //scanf("%d",&inutile);
		 }
         p=p->NEXT_SORG;
    }
return;

}

// INIZIALIZZAZIONE DELLE SORGENTI CBR
// viene passato il vettore di sorgenti interessato e l'indicatore del RT
void inizializza_sorgenti_TIPO2(int RT)
{
pTIPO_2 p=VETTORE_SORGENTI_RT_DL[RT].T2;
//printf("\nInizializzo il traffico delle sorgenti di TIPO 2 verso il RT %d \n",RT+1);
//scanf("%d",&inutile);
double casuale;
while (p!=NULL)
      {
      casuale=random_real((p->L_IP)/(double)(p->RATE_PICCO));
      //printf("%lf ",casuale);*****
      //MA PERCHE' NON ABBIAMO DIVISO PER RAND_MAX+1
      //(double)(rand()/RAND_MAX)*((p->L_IP)/(double)(p->RATE_PICCO));
      // variabile casuale inizializzata tra 0 e la durata in tempo del
      // pacchetto IP assegnato a quella sorgente
       p->TNEXT=casuale+((p->L_IP)/(double)(p->RATE_PICCO));
       //printf("\nTNEXT e' pari a %lf \n",p->TNEXT);*****
       //scanf("%d",&inutile);
      //TNEXT in questo caso puo' essere visto come l'instante in cui
      //la sorgente ha finito di presentarci il primo pacchetto utile per la trasmissione.
      //Non si considerano i byte emessi dalla sorgente prima di questo pacchetto
      p=p->NEXT_SORG;
      }

return;

}

// calcola la determinazione del tempo di interarrivo secondo
// la distribuzione di POISSON
double POISSON(int f)
// f = frequenza media di interarrivo in HERTZ
{
double x;
x=((1+rand())/(double)(RAND_MAX+1));
//Abbiamo lasciato RAND_MAX+1 anche se ci sono stati problemi sul Visual C++ compilando il programma con compilatore //"C" 
if (x<0) x*=-1;
x=0-log(x);
x=x/f;
//printf("\nIl valore del tempo di interarrivo  e' pari a %lf\n",x);*****
return x;
}


// INIZIALIZZAZIONE DELLE SORGENTI BEST EFFORT
// viene passato il vettore di sorgenti interessato e l'indicatore del RT
void inizializza_sorgenti_TIPO3(int RT)
{
pTIPO_3 p=VETTORE_SORGENTI_RT_DL[RT].T3;
//printf("\nInizializzo il traffico delle sorgenti di TIPO 3 verso il RT %d \n",RT+1);
//scanf("%d",&inutile);
while (p!=NULL)
      {
      p->TNEXT=POISSON(p->FREQUENZA_MEDIA);
      //printf("\nTNEXT e' pari a %lf\n",p->TNEXT);*****
      p=p->NEXT_SORG;
      //scanf("%d",&inutile);
      }
     
return;
}


void CREA_MACPDU_GB(int FLAG,int DIMENSIONE,double MARCHIO,int RT,int ID,int OFFSET,int tipo_traffico)
{
// in base a flag capisce su quale buffer attaccare le MAC PDU
// 0 - UPLINK
// 1 - DOWNLINK
BUFFER p;
int numero_MACPDU,conta;
numero_MACPDU=(int)ceil(DIMENSIONE/(double)PAYLOAD_AL);
//printf("\nDIMENSIONE e' %d\n",DIMENSIONE);*****
//printf("\nMAC PDU GB tipo %d generate al tempo %lf verso RT %dsono%d\n",tipo_traffico,MARCHIO,RT+1,numero_MACPDU);*
//scanf("%d",&inutile);

if (FLAG==0)
   {
   p=CODE_GB_RT[RT];
   CONT_IP_GB_RT[RT]+=1;
   CONT_MACPDU_GB_RT[RT]+=numero_MACPDU;
   }
else
   {
   p=CODE_GB_RN[RT];
   CONT_IP_GB_RN[RT]+=1;
   CONT_MACPDU_GB_RN[RT]+=numero_MACPDU;
   }
if (p==NULL)          // LISTA VUOTA
   {
   if (FLAG==0)
      {
      CODE_GB_RT[RT]=(BUFFER)malloc(sizeof(struct MAC_PDU));
      p=CODE_GB_RT[RT];
      }
   else
      {
      CODE_GB_RN[RT]=(BUFFER)malloc(sizeof(struct MAC_PDU));
      p=CODE_GB_RN[RT];
      }
   }
else                  // LISTA NON VUOTA
   {
   while (p->NEXT_MACPDU!=NULL)   p=p->NEXT_MACPDU;
 
   p->NEXT_MACPDU=(BUFFER)malloc(sizeof(struct MAC_PDU));
   p=p->NEXT_MACPDU;
   }
conta=1;
p->SORGENTE=ID;
p->T_GEN=MARCHIO;
p->TIPO_TRAFFICO=tipo_traffico;
if (FLAG==0) p->NS_IP=CONT_IP_GB_RT[RT];
else p->NS_IP=CONT_IP_GB_RN[RT];
p->NS_MACPDU=conta+OFFSET;

while (conta<numero_MACPDU)
      {
	  p->NEXT_MACPDU=(BUFFER)malloc(sizeof(struct MAC_PDU));
      p=p->NEXT_MACPDU;
      p->SORGENTE=ID;
      p->T_GEN=MARCHIO;
      p->TIPO_TRAFFICO=tipo_traffico;
      if (FLAG==0) p->NS_IP=CONT_IP_GB_RT[RT];
      else p->NS_IP=CONT_IP_GB_RN[RT];
      p->NS_MACPDU=conta+OFFSET;
      conta++;
      }
p->NEXT_MACPDU=NULL;

return;
}


void CREA_MACPDU_BE(int FLAG,int DIMENSIONE,double MARCHIO,int RT,int ID,int tipo_traffico)

{
// in base a flag capisce su quale buffer attaccare le MAC PDU
// 0 - UPLINK
// 1 - DOWNLINK
BUFFER p;
int numero_MACPDU,conta;
int lunghezza;

lunghezza=LUNGHEZZA_CODE_BE[RT];  

if (lunghezza<CAPIENZA_BUFFER) 
{

numero_MACPDU=(int)ceil((double)DIMENSIONE/PAYLOAD_AL);
//printf("\nMAC PDU BE tipo %d generate al tempo %lf verso RT %d sono %d\n",tipo_traffico,MARCHIO,RT+1,numero_MACPDU);
//printf("\nSto valutando l'RT %d\n",RT+1);
//scanf("%d",&inutile);
if (FLAG==0)
   {
   p=CODE_BE_RT[RT];
   CONT_IP_BE_RT[RT]+=1;
   CONT_MACPDU_BE_RT[RT]+=numero_MACPDU;
   }
else
   {
   p=CODE_BE_RN[RT];
   CONT_IP_BE_RN[RT]+=1;
   CONT_MACPDU_BE_RN[RT]+=numero_MACPDU;
   }
   
if (p==NULL)          // LISTA VUOTA
   {
   if (FLAG==0)
      {
      CODE_BE_RT[RT]=(BUFFER)malloc(sizeof(struct MAC_PDU));
      p=CODE_BE_RT[RT];
      }
   else
      {
      CODE_BE_RN[RT]=(BUFFER)malloc(sizeof(struct MAC_PDU));
      p=CODE_BE_RN[RT];
      }
   }
else                  // LISTA NON VUOTA
   {
   while (p->NEXT_MACPDU!=NULL) p=p->NEXT_MACPDU;
   p->NEXT_MACPDU=(BUFFER)malloc(sizeof(struct MAC_PDU));
   p=p->NEXT_MACPDU;
   }

conta=1;
p->SORGENTE=ID;
p->T_GEN=MARCHIO;
p->TIPO_TRAFFICO=tipo_traffico;
if (FLAG==0) p->NS_IP=CONT_IP_BE_RT[RT];
else p->NS_IP=CONT_IP_BE_RN[RT];
p->NS_MACPDU=conta;
lunghezza++;


while ((conta<numero_MACPDU)&&(lunghezza<(CAPIENZA_BUFFER)))
      {
      p->NEXT_MACPDU=(BUFFER)malloc(sizeof(struct MAC_PDU));
      p=p->NEXT_MACPDU;
      p->SORGENTE=ID;
      p->T_GEN=MARCHIO;
      p->TIPO_TRAFFICO=tipo_traffico;
      if (FLAG==0) p->NS_IP=CONT_IP_BE_RT[RT];
      else p->NS_IP=CONT_IP_BE_RN[RT]; //ORRORE!!
      p->NS_MACPDU=conta;
      conta++;
      lunghezza++;
      }
LUNGHEZZA_CODE_BE[RT]=lunghezza;      
if ((lunghezza==(CAPIENZA_BUFFER))&&(conta<numero_MACPDU)) OVERFLOW_BE_HAPPENED[RT]=1;
else OVERFLOW_BE_HAPPENED[RT]=0;
//Abbiamo supposto che l'indicatore di overflow valga o 1 o 0 a seconda che sia avvenuto o meno OVERFLOW      
p->NEXT_MACPDU=NULL;

}

return;
}


// PROCEDURE DI GENERAZIONE TRAFFICO
// TRAFFICO ON-OFF
void GENERA_TRAFFICO_TIPO1(int FLAG,int RT, double tempo)
// FLAG vale 0 per l'UPLINK e 1 per il DOWNLINK
{
pTIPO_1 p;
int appoggio;
int conta_TOFF=0;
int tipo_traffico=1;
double T_AUX=0;
int centra,noncentra;
if (FLAG==1) p=VETTORE_SORGENTI_RT_DL[RT].T1;
else p=VETTORE_SORGENTI_RT_UL[RT].T1;


while (p!=NULL)
      {
      while ((p->TNEXT)<tempo)
            {
            if ((double)(p->BYTE)<((p->RATE_PICCO)*(p->T_ON)))
               {
               if ((double)((p->BYTE)+(p->L_IP))>((p->RATE_PICCO)*(p->T_ON)))
                  {
                  // Abbiamo sforato, forse anche parecchio
                  centra=(int)ceil((p->RATE_PICCO)*(p->T_ON))-(p->BYTE);
                  appoggio=p->L_IP-centra;
                  conta_TOFF=(int)(floor)(appoggio/((p->T_ON)*(p->RATE_PICCO)));
                  appoggio=(int)(appoggio-((conta_TOFF)*(ceil)((p->T_ON)*(p->RATE_PICCO))));
                   //Ora in appoggio c' l'ultimo gruppo di bytes  del pacchetto
                  p->TNEXT=p->TNEXT+(centra/p->RATE_PICCO)+p->T_OFF+(conta_TOFF*(p->T_OFF+p->T_ON))+(appoggio/p->RATE_PICCO);		
                  p->BYTE=p->BYTE+p->L_IP;                 
                  }
               else
                  {
                  // Non abbiamo sforato
                  T_AUX=(p->TNEXT)+(p->L_IP)/(double)(p->RATE_PICCO);
                  CREA_MACPDU_GB(FLAG,p->L_IP,T_AUX,RT,p->IDENTIFICATIVO,0,tipo_traffico);
                  p->BYTE+=p->L_IP;
                  p->TNEXT=T_AUX;
                 
                  }
               }
            else
               {
               conta_TOFF=(int)(floor)(p->BYTE/((p->T_ON)*(p->RATE_PICCO)));
               p->BYTE=(int)(p->BYTE-(conta_TOFF)*((ceil)((p->T_ON)*(p->RATE_PICCO))));
               CREA_MACPDU_GB(FLAG,p->L_IP,p->TNEXT,RT,p->IDENTIFICATIVO,0,tipo_traffico);            
               }
            }
      p=p->NEXT_SORG;
      }
//printf("\nFine generazione traffico ON/OFF al RT %d con tempo fine TS %lf\n",RT+1,tempo); 
return;
}


// TRAFFICO CBR
void GENERA_TRAFFICO_TIPO2(int FLAG,int RT, double tempo)
{
int tipo_traffico=2;
pTIPO_2 p;
if (FLAG==1) p=VETTORE_SORGENTI_RT_DL[RT].T2;
else p=VETTORE_SORGENTI_RT_UL[RT].T2;
while (p!=NULL)
      {
      while (p->TNEXT<=tempo)
      {
          CREA_MACPDU_GB(FLAG,p->L_IP,p->TNEXT,RT,p->IDENTIFICATIVO,0,tipo_traffico);
          p->TNEXT+=((p->L_IP)/(double)(p->RATE_PICCO));
          
      }
      p=p->NEXT_SORG;
      }
//printf("\nFine generazione traffico CBR al RT %d con tempo fine TS %lf\n",RT+1,tempo);
return;
}

// TRAFFICO BEST EFFORT
void  GENERA_TRAFFICO_TIPO3(int FLAG,int RT, double tempo)
{
pTIPO_3 p;
int tipo_traffico=3;
if (FLAG==1)
    p=VETTORE_SORGENTI_RT_DL[RT].T3;
else
    p=VETTORE_SORGENTI_RT_UL[RT].T3;
while (p!=NULL)
      {
      while (p->TNEXT<=tempo)
            {
            CREA_MACPDU_BE(FLAG,p->L_IP,p->TNEXT,RT,p->IDENTIFICATIVO,tipo_traffico);
            p->TNEXT+=POISSON(p->FREQUENZA_MEDIA);
            //printf("\nTNEXT e' pari a %lf\n",p->TNEXT);*****
            }
      p=p->NEXT_SORG;
      }
//printf("\nFine generazione traffico BE al RT %d con tempo fine TS %lf\n",RT+1,tempo);
return;
}

// CALCOLA LA BANDA RSVP E LA BANDA MAC DA ASSEGNARE ALLE SINGOLE SORGENTI RESIDENTI
// NEL RN E LE CUI CONNESSIONI SONO DIRETTE AI VARI RTs.
// IL CALCOLO DELLE BANDE E' FATTO A PARTIRE DAI PARAMETRI DELLA SORGENTE E LA PROCEDURA
// HA COME RISULTATO L'AGGIORNAMENTO DEL CAMPO BANDA_MAC DEL RECORD DELLA SORGENTE


// STRUTTURE NECESSARIE PER LA COSTRUZIONE DELLA MATRICE
struct TX_DL
{
int GB;
int BE;
};
struct TX_DL TRASMISSIONE_DL[NRT][NTS];


struct ASSEGNAZIONE{

                int GB;
                int BE;
                };

struct ASSEGNAZIONE ASSEGNAZIONE_DL[NRT];
struct ASSEGNAZIONE ASSEGNAZIONE_DL_PORTATA[NRT];

 void inizializza_ASSEGNAZIONE_DL()
 {
 int i;
  for (i=0;i<NRT;i++)
  {
   ASSEGNAZIONE_DL[i].GB=0;
   ASSEGNAZIONE_DL[i].BE=0;
  }
  //printf("\nAssegnazione DL inizializzata\n");
  return;
 }

//PER OGNI TS DICE QUANTI CODICI SONO IMPEGNATI
int SITUAZIONE_TS_DL[NTS];

void inizializza_SITUAZIONE_TS_DL()
{
int i;
//NEL TS DOVE STA L'ALLOCATIONAL CHANNEL(E NON SOLO LUI, AD ES
//ANCHE L'ACK CHANNEL) CI SONO SEMPRE "SEGNALAZIONE_DL" TC_PAIR OCCUPATE
 
 for(i=0;i<NTS;i++) SITUAZIONE_TS_DL[i]=0;
 SITUAZIONE_TS_DL[POSIZIONE_PAG_CH]=SEGNALAZIONE_DL;
 //printf("\nSituazione TS DL inizializzata\n");
 //printf("\n\n");
 //for(i=0;i<NTS;i++) printf("%d ",SITUAZIONE_TS_DL[i]);
 //printf("\n\n");
 //scanf("%d",&inutile);
 return;

}

int TS_PIENO(int TS)
{
// IL TS E' PIENO SE TUTTI I "K" CODICI SONO OCCUPATI
 if (SITUAZIONE_TS_DL[TS]==K) return(1);
 else return(0);

}

int CODICE_PIENO(int TS,int CODICE)
{
//IL CAMPO "RT" VALE "-1" SE E SOLO SE QUELLA TC_PAIR E' LIBERA
//VALE "-2" SE E' DI SEGNALAZIONE. E' >0 SE E' ASSEGNATA AD ALTRO UTENTE
 if (MATRICE_CODICI[CODICE][TS].RT==-1) return(0);
 else return(1);
}


void inizializza_TRASMISSIONE_DL()
{
int i,j;
for (i=0;i<NRT;i++)
  {
   for (j=0;j<NTS;j++)
    {
TRASMISSIONE_DL[i][j].GB=0;
TRASMISSIONE_DL[i][j].BE=0;
    }
  }
//printf("\nTrasmissione DL inizializzata\n");
return;
}


// PROCEDURA PER LA COSTRUZIONE DELLA MATRICE DI TRASMISSIONE CHE SERVE PER LA MEMORIZZAZIONE DELLE PDU DI CLASSE
// GB E BE CHE DEVONO ESSERE TRASMESSE NEL DOWNLINK.LE MAC-PDU DI CLASSE GB E DI CLASSE BE CHE DEVONO ESSERE TRASMESSE
// SARANNO INVIDUABILI UNIVOCAMENTE ALL'INTERNO DELLA MATRICE TRAMITE L'IDENTIFICATIVO DEL RT E DEL TS.


void costruisci_TRASMISSIONE_DL()
{
int i,j;
for (i=0;i<K;i++)
 {
 for (j=0;j<NTS;j++)
   {
    if (MATRICE_CODICI[i][j].TIPO==1) TRASMISSIONE_DL[(MATRICE_CODICI[i][j].RT)-1][j].GB+=1 ;

    else if (MATRICE_CODICI[i][j].TIPO==2) TRASMISSIONE_DL[(MATRICE_CODICI[i][j].RT)-1][j].BE+=1 ; 
    //TIPO  uguale a 2:TRAFFICO BE
   } 
 }

//printf("\nTrasmissione DL costruita\n");
return;
}


int ASSEGNA_RISORSE_DL(FILE* MAT_CODICI)
{
int TUTTI_CONTENTI=0,PDU_ANCORA_ASSEGNABILI=NTS*K-SEGNALAZIONE_DL;
int i,j;

//PRIMO STEP DELLO SCHEDULING: ASSEGNA IL DOVUTO ALLE CONNESSIONI DIRETTE AI DIVERSI RT
for(i=0;i<NRT;i++)
{
  ASSEGNAZIONE_DL[i].GB=minimo(BANDE_TOTALI_MAC_DL[i],(int)STATO_CODE_AL_RN[i].LUNG1);

//printf("\n\nRT %d : Bande totali MAC GB DL e' %d e stato code GB al RN  e' %d\n",i+1,BANDE_TOTALI_MAC_DL[i],(int)STATO_CODE_AL_RN[i].LUNG1);
fprintf(MAT_CODICI,"\n\nRT %d : Bande totali MAC GB DL e' %d e stato code GB al RN e' %d\n",i+1,BANDE_TOTALI_MAC_DL[i],(int)STATO_CODE_AL_RN[i].LUNG1);
//printf("\n\nRT %d : Stato code BE al RN e' %d\n",i+1,(int)STATO_CODE_AL_RN[i].LUNG2);
fprintf(MAT_CODICI,"\n\nRT %d : Stato code BE al RN e' %d\n",i+1,(int)STATO_CODE_AL_RN[i].LUNG2);
//printf("\nL'assegnazione GB DL al RT %d e' %d\n",i+1,ASSEGNAZIONE_DL[i].GB);
STATO_CODE_AL_RN[i].LUNG1-=ASSEGNAZIONE_DL[i].GB;
PDU_ANCORA_ASSEGNABILI-=ASSEGNAZIONE_DL[i].GB;
}

//SECONDO STEP DELLO SCHEDULING: ASSEGNA UNA MAC PDU AD OGNI RT FINCHE' NON CI SONO
// PIU' MAC PDU DA POTER ASSEGNARE OPPURE NON CI SONO PIU' RICHIESTE GB IN ATTESA
i=INIZIO_ROUND_ROBIN_GB;

while((PDU_ANCORA_ASSEGNABILI!=0) && (TUTTI_CONTENTI<NRT))
{
//printf("\nSECONDO STEP dello SCHEDULING\n");
//printf("\nPDU ancora assegnabili= %d,i RT felici x  ora sono %d su %d\n", PDU_ANCORA_ASSEGNABILI,TUTTI_CONTENTI,NRT);
 if (STATO_CODE_AL_RN[i].LUNG1!=0)
   {
     ASSEGNAZIONE_DL[i].GB+=1;
     STATO_CODE_AL_RN[i].LUNG1-=1;
     PDU_ANCORA_ASSEGNABILI-=1;
   }
 else
    {
        if (STATO_CODE_AL_RN[i].BUFFER_VUOTI!=1)
        // IL RR ASSEGNA UNA MAC PDU A OGNI RT IN ORDINE A PARTIRE DA INIZIO_ROUND_ROBIN.
        // QUINDI RIPASSERO' PIU' VOLTE PER LO STESSO RT E SERVE SAPERE SE QUESTO RT
        // HA ANCORA QUALCHE PDU NEI BUFFER
          {
           TUTTI_CONTENTI+=1;
           STATO_CODE_AL_RN[i].BUFFER_VUOTI=1;
           }
     }

 i=(i+1)%(NRT); //PER CONTINUARE IL ROUND ROBIN CICLANDO DALL'INIZIO
}
 
//scanf("%d",&inutile);
INIZIO_ROUND_ROBIN_GB=i;
//LA PROSSIMA TRAMA REINIZIERO' IL ROUND ROBIN DAL RT SUCCESSIVO A QUELLO DOVE
//MI SONO FERMATO NELLA TRAMA CORRENTE

for(j=0;j<NRT;j++)
{
 STATO_CODE_AL_RN[j].BUFFER_VUOTI=0;
}
TUTTI_CONTENTI=0;

//TERZO STEP DELLO SCHEDULING: ASSEGNA UNA MAC PDU AD OGNI RT FINCHE' NON CI SONO
// PIU' MAC PDU DA POTER ASSEGNARE OPPURE NON CI SONO PIU' RICHIESTE BE IN ATTESA
i=INIZIO_ROUND_ROBIN_BE;
while((PDU_ANCORA_ASSEGNABILI!=0)&&(TUTTI_CONTENTI<NRT))
{
//printf("\nTERZO STEP dello SCHEDULING\n");
//printf("\nPDU ancora assegnabili= %d,i RT felici x ora sono %d su %d\n",PDU_ANCORA_ASSEGNABILI,TUTTI_CONTENTI,NRT);
 if (STATO_CODE_AL_RN[i].LUNG2!=0)
   {
     ASSEGNAZIONE_DL[i].BE+=1;
     STATO_CODE_AL_RN[i].LUNG2-=1;
     PDU_ANCORA_ASSEGNABILI-=1;
   }
 else
    {
        if (STATO_CODE_AL_RN[i].BUFFER_VUOTI!=1)
        // IL RR ASSEGNA UNA MAC PDU A OGNI RT IN ORDINE A PARTIRE DA INIZIO_ROUND_ROBIN.
        // QUINDI RIPASSERO' PIU' VOLTE PER LO STESSO RT E SERVE SAPERE SE QUESTO RT
        // HA ANCORA QUALCHE PDU NEI BUFFER
          {
           TUTTI_CONTENTI+=1;
           STATO_CODE_AL_RN[i].BUFFER_VUOTI=1;
           }
     }

 i=(i+1)%(NRT); //PER CONTINUARE IL ROUND ROBIN CICLANDO DALL'INIZIO
}

//LA PROSSIMA TRAMA REINIZIERO' IL ROUND ROBIN DAL RT SUCCESSIVO A QUELLO DOVE
//MI SONO FERMATO NELLA TRAMA CORRENTE
INIZIO_ROUND_ROBIN_BE=i;

for(j=0;j<NRT;j++)
{
 STATO_CODE_AL_RN[j].BUFFER_VUOTI=0;
}

//printf("\nMAC PDU ancora assegnabili alla fine sono %d, i felici sono %d\n",PDU_ANCORA_ASSEGNABILI,TUTTI_CONTENTI);
//scanf("%d",&inutile);

return(0);
}



//Conta il numero di elementi in coda in un buffer
int NUMERO_ELEMENTI_CODA(BUFFER q)
{
 int conta=0;
 BUFFER p=q;
 while (p!=NULL)
 {
  p=p->NEXT_MACPDU;
  conta++;
 }
 return (conta);
}



void ELABORA_STATO_CODE(int RT,BUFFER p_GB,BUFFER q_BE ,int cont)
{
   	int temp1=0;
	int temp2=0;
	int appoggio;

    temp1=NUMERO_ELEMENTI_CODA(p_GB);
    appoggio=TRASMISSIONE_DL[RT][cont].GB+TRASMISSIONE_DL[RT][cont+1].GB;
    STATO_CODE_AL_RN[RT].LUNG1=(double)massimo(0,temp1-appoggio);
	if ((temp1!=0) || (appoggio!=0))
    	{	
	//printf("\n\nPer il RT %d\n\n",RT+1);
    //printf("\nNUMERO ELEMENTI IN CODA GB e' %d\n",temp1);
    //printf("\nNumero MAC PDU non trasmesse ma gia' organizzate per la trasmissione e' %d\n",appoggio);
	//printf("\nNUMERO ELEMENTI IN CODA - RESIDUI DA TX e' %d\n",temp1-appoggio);
    //printf("\nSTATO CODE GB e' %d\n",(int)STATO_CODE_AL_RN[RT].LUNG1);
	}


    temp2=NUMERO_ELEMENTI_CODA(q_BE);
    appoggio=TRASMISSIONE_DL[RT][cont].BE+TRASMISSIONE_DL[RT][cont+1].BE;
    STATO_CODE_AL_RN[RT].LUNG2=(double)massimo(0,temp2-appoggio);
    if ((temp2!=0) || (appoggio!=0))
    {
    //printf("\n\nPer il RT %d\n\n",RT+1);
    //printf("\nNUMERO ELEMENTI IN CODA BE e' %d\n",temp2);
    //printf("\nNumero MAC PDU non trasmesse ma gia' organizzate per la trasmissione e' %d\n",appoggio);
    //printf("\nNUMERO ELEMENTI IN CODA - RESIDUI DA TX e' %d\n",temp2-appoggio);
    //printf("\nSTATO CODE BE e' %d\n",(int)STATO_CODE_AL_RN[RT].LUNG2);
    }

return;
}




//PROCEDURA CHE ASSEGNA IN MODO RANDOM LE MAC PDU AI VARI RT.
//IL NUMERO DI MAC PDU ASSEGNATE AI VARI RT E' INVECE DECISO
//DALLA PROCEDURA "ASSEGNA_RISORSE_DL".
//AD OGNI FINE TRAMA LA "MATRICE_CODICI" VA REINIZIALIZZATA.



void riempi_MATRICE_CODICI()
{
int RT,i,TS_ASSEGNATO,CODICE_ASSEGNATO,CLASSE,appoggio;

inizializza_SITUAZIONE_TS_DL();


//INIZIO L'ASSEGNAZIONE RANDOM DELLE MAC PDU DA "RT" SCELTO IN MODO CASUALE
RT=random_int(NRT); // 0<=RT<=NRT-1   
//printf("\nil valore di RT scelto e' %d\n",RT+1);
for (i=0;i<NRT;i++)
{	
	//printf("\nASSEGNAZIONE DL GB PER IL RT %d VALE %d\n",RT+1,ASSEGNAZIONE_DL[RT].GB);
	while (ASSEGNAZIONE_DL[RT].GB!=0)
        {   

        //printf("\nAssegnazione DL per il RT %d di classe GB e' %d\n",RT+1,ASSEGNAZIONE_DL[RT].GB);
        TS_ASSEGNATO=random_int(NTS);
		//printf("\nTIME SLOT ASSEGNATO e' %d \n",TS_ASSEGNATO);
	    //scanf("%d",&inutile);
		//appoggio=TS_PIENO(TS_ASSEGNATO);
		//printf("%d",appoggio);
     	while (TS_PIENO(TS_ASSEGNATO)==1)
         //TS_ASSEGNATO RESTITUISCE "1"  SE IL TS HA TUTTI I CODICI ASSEGNATI
     	{
      	TS_ASSEGNATO=(TS_ASSEGNATO+1)%(NTS);
     	}
		//printf("\n IL TS ASSEGNATO IS THE NUMBER %d \n",TS_ASSEGNATO);

        CODICE_ASSEGNATO=random_int(K);


        while (CODICE_PIENO(TS_ASSEGNATO,CODICE_ASSEGNATO)==1)
        //CODICE_PIENO RESTITUISCE "1" SE QUELLA COPPIA <TS,CODICE> E' STATA ASSEGNATA
        {
        CODICE_ASSEGNATO=(CODICE_ASSEGNATO+1)%(K);
        }
        //printf("\n IL CODICE ASSEGNATO IS THE NUMBER %d \n",CODICE_ASSEGNATO);
        MATRICE_CODICI[CODICE_ASSEGNATO][TS_ASSEGNATO].RT=RT+1;
        MATRICE_CODICI[CODICE_ASSEGNATO][TS_ASSEGNATO].TIPO=1;
        //CLASSE puo' essere utile
        //CLASSE=MATRICE_CODICI[CODICE_ASSEGNATO][TS_ASSEGNATO].TIPO;
        if (((cont_trame+1)>=INIZIO_ANALISI)&&((cont_trame+1)<=FINE_ANALISI))
        {
		 //Numero di volte che un certo codice e' assegnato al particolare RT
		 hyst_CODICE_PROBABILE_GB[RT][CODICE_ASSEGNATO]+=1;
         normalizza_COD_PROBABILE_GB[RT]+=1;
        }

        //AGGIUNGO IL CODICE ASSEGNATO A QUEL RT IN QUEL TS
       // AGGIUNGI_RISORSA(PAGING_CHANNEL,CODICE_ASSEGNATO,RT,TS_ASSEGNATO);

        ASSEGNAZIONE_DL[RT].GB-=1;
		SITUAZIONE_TS_DL[TS_ASSEGNATO]+=1;

	}
    //printf("\nASSEGNAZIONE DL BE PER IL RT %d VALE %d\n",RT+1,ASSEGNAZIONE_DL[RT].BE);
    while (ASSEGNAZIONE_DL[RT].BE!=0)
    {   
  
        //printf("\nAssegnazione DL per il RT %d di classe BE e' %d\n",RT+1,ASSEGNAZIONE_DL[RT].BE);
        TS_ASSEGNATO=random_int(NTS);
      //printf("\nTIME SLOT ASSEGNATO e' %d \n",TS_ASSEGNATO);
	  //scanf("%d",&inutile);
	  //appoggio=TS_PIENO(TS_ASSEGNATO);
      //printf("%d",appoggio);
     	while (TS_PIENO(TS_ASSEGNATO)==1)
     	{
      	TS_ASSEGNATO=(TS_ASSEGNATO+1)%(NTS);
     	}
        //printf("\n IL TS ASSEGNATO IS THE NUMBER %d \n",TS_ASSEGNATO);
        CODICE_ASSEGNATO=random_int(K);

        while (CODICE_PIENO(TS_ASSEGNATO,CODICE_ASSEGNATO)==1)
        {
        CODICE_ASSEGNATO=(CODICE_ASSEGNATO+1)%(K);
		//printf("\nTRAMA %d\n",cont_trame+1);
		//printf("\nTS assegnato %d ha situazione %d\n",TS_ASSEGNATO,(SITUAZIONE_TS_DL[TS_ASSEGNATO]));
		//printf("\nIl codice %d appartiene al RT %d\n",CODICE_ASSEGNATO,MATRICE_CODICI[CODICE_ASSEGNATO][TS_ASSEGNATO].RT);
		
        }
		//printf("\n IL CODICE ASSEGNATO IS THE NUMBER %d \n",CODICE_ASSEGNATO);
        MATRICE_CODICI[CODICE_ASSEGNATO][TS_ASSEGNATO].RT=RT+1;
        MATRICE_CODICI[CODICE_ASSEGNATO][TS_ASSEGNATO].TIPO=2;
        //CLASSE puo' essere utile
        //CLASSE=MATRICE_CODICI[CODICE_ASSEGNATO][TS_ASSEGNATO].TIPO;
		
        if (((cont_trame+1)>=INIZIO_ANALISI)&&((cont_trame+1)<=FINE_ANALISI))
        {
        //Numero di volte che un certo codice e' assegnato al particolare RT
        hyst_CODICE_PROBABILE_BE[RT][CODICE_ASSEGNATO]+=1;
        normalizza_COD_PROBABILE_BE[RT]+=1;
        }


       //AGGIUNGO IL CODICE ASSEGNATO A QUEL RT IN QUEL TS
       //AGGIUNGI_RISORSA(PAGING_CHANNEL,CODICE_ASSEGNATO,RT,TS_ASSEGNATO);
		ASSEGNAZIONE_DL[RT].BE-=1;
		SITUAZIONE_TS_DL[TS_ASSEGNATO]+=1;
    }
    RT=(RT+1)%(NRT);

}

//printf("\nRIEMPI MATRICE DEI CODICI ESEGUITA\n");
return;
}


void LIBERA_LISTA(BUFFER punt)
{

BUFFER temp;
if (punt==NULL) //non ci sono elementi da togliere
{
return;
}
else
{
  if (punt->NEXT_MACPDU==NULL)// c'e' un solo elemento da togliere
  {
  free (punt);
  punt=NULL;
  }
  else
  {
   while (punt->NEXT_MACPDU!=NULL) //ci sono pi elementi da togliere
   {
	   temp=punt;
	   punt=punt->NEXT_MACPDU;
	   free (temp);
   }
   free (punt);
   punt=NULL;
  }
}

return;
}

  struct appoggio{

	  int ON_OFF;
	  int CBR;
          int GB;
          int BE;
  };

  struct appoggio APPOGGIO_PORTATA[NRT];



  void inizializza_STATISTICHE()
  {
   int i,j;

	//INIZIALIZZO GLI ISTOGRAMMI DELLA PORTATA GB e BE PER OGNI RT
   for (i=0;i<NRT;i++)
	   for (j=0;j<NTS*K-SEGNALAZIONE_DL+1;j++)
	   {
		hyst_portata_ON_OFF[i][j]=0;
		hyst_portata_CBR[i][j]=0;
		hyst_portata_GB[i][j]=0;
		hyst_portata_BE[i][j]=0;
	   }
   
   //INIZIALIZZO GLI ISTOGRAMMI DEL RIEMPIMENTO DEI BUFFER GB e BE
   for (i=0;i<NRT;i++)
   {
    	for (j=0;j<CAPIENZA_BUFFER+2;j++)
        {
         hyst_riempimento_GB[i][j]=0;
         hyst_riempimento_BE[i][j]=0;
        }
   }

   //INIZIALIZZO GLI ISTOGRAMMI DEI RITARDI DELLE MAC PDU BE
   for (i=0;i<NRT;i++)
   {
    	for (j=0;j<MAX_RITARDO_TS+1;j++)
        {
         hyst_delay_BE[i][j]=0;
        }
        normalizza_delay_BE[i]=0;
   }
   
   
   //INIZIALIZZO LE NORMALIZZA DELAY ON_OFF E CBR
   
   for (i=0;i<NRT;i++)
    {
    normalizza_delay_ON_OFF[i]=0;
    normalizza_delay_CBR[i]=0;
    }

   // INIZIALIZZO I VETTORI DEI RITARDI MIN E MAX
   for (i=0;i<NRT;i++)
   {
     DELAY_ON_OFF[i].MIN=MAX_RITARDO_TS*DURATA_TS;
     DELAY_CBR[i].MIN=MAX_RITARDO_TS*DURATA_TS;
     DELAY_BE[i].MIN=MAX_RITARDO_TS*DURATA_TS;

     DELAY_ON_OFF[i].MAX=0;
     DELAY_CBR[i].MAX=0;
     DELAY_BE[i].MAX=0;
   }

   //INIZIALIZZO GLI ISTOGRAMMI DELLA PROBABILITA' CHE UN CERTO CODICE SIA ASSEGNATO AL DETERMINATO RT

   for (i=0;i<NRT;i++)
   {
	   for (j=0;j<K;j++) hyst_CODICE_PROBABILE_GB[i][j]=0;
           normalizza_COD_PROBABILE_GB[i]=0;
   }

   for (i=0;i<NRT;i++)
   {
	   for (j=0;j<K;j++) hyst_CODICE_PROBABILE_BE[i][j]=0;
           normalizza_COD_PROBABILE_BE[i]=0;
   }

	for (i=0;i<NRT;i++) 
		
	{
		APPOGGIO_PORTATA[i].ON_OFF=0; 
		APPOGGIO_PORTATA[i].CBR=0; 
        APPOGGIO_PORTATA[i].GB=0;
        APPOGGIO_PORTATA[i].BE=0;	
	}

  //printf("\nStatistiche inizializzate\n");
  return;

  }


//CALCOLA STIME DEI RITARDI MEDI E DELLE VARIANZE IN BASE AL TEMPO ASSOLUTO E
//AL CAMPO "T_GEN" DELLE MAC PDU.
//QUESTA PROCEDURA VIENE CHIAMATA AD OGNI TS E AGGIORNA LE STATISTICHE.
 void CALCOLA_STATISTICHE_BASE_TS(double t,int RT,BUFFER p_GB,BUFFER q_BE,int numero_GB,int numero_BE)
{
 double ritardo=0;
 int ritardo_in_TS=0;

 // CALCOLO LE STATISTICHE PER LA CLASSE GB

BUFFER p=p_GB;
BUFFER q=q_BE;
pTIPO_1 p1;
pTIPO_2 p2;
pTIPO_3 p3;


if (numero_GB>CAPIENZA_BUFFER) hyst_riempimento_GB[RT][CAPIENZA_BUFFER+1]+=1;
else hyst_riempimento_GB[RT][numero_GB]+=1;


while (p!=NULL)
{
 ritardo=t-(p->T_GEN);
 if (p->TIPO_TRAFFICO==1)
   {
   p1=VETTORE_SORGENTI_RT_DL[RT].T1;
   while ((p1->IDENTIFICATIVO)!=(p->SORGENTE)) p1=p1->NEXT_SORG;
   p1->PRIMO_MOMENTO+=ritardo;
   p1->SECONDO_MOMENTO+=pow(ritardo,2);
   normalizza_delay_ON_OFF[RT]+=1;

    //printf("\nCalcolo statistiche per sorg GB, id %d\n", p1->IDENTIFICATIVO);
   if (ritardo>=DELAY_ON_OFF[RT].MAX) DELAY_ON_OFF[RT].MAX=ritardo;
   if (ritardo<= DELAY_ON_OFF[RT].MIN) DELAY_ON_OFF[RT].MIN=ritardo;

   APPOGGIO_PORTATA[RT].ON_OFF+=1;
  // printf("\nAPPOGGIO_PORTATA ON_OFF per il RT %d  %d \n",RT,APPOGGIO_PORTATA[RT].ON_OFF);
  // scanf("%d",&inutile);
   }
  else 
    {
     if (p->TIPO_TRAFFICO==2)
     {
      p2=VETTORE_SORGENTI_RT_DL[RT].T2;
      while ((p2->IDENTIFICATIVO)!=(p->SORGENTE)) p2=p2->NEXT_SORG;
      p2->PRIMO_MOMENTO+=ritardo;
      p2->SECONDO_MOMENTO+=pow(ritardo,2);
      normalizza_delay_CBR[RT]+=1;
      
      if (ritardo>=DELAY_CBR[RT].MAX) DELAY_CBR[RT].MAX=ritardo;
      if (ritardo<= DELAY_CBR[RT].MIN) DELAY_CBR[RT].MIN=ritardo;

      APPOGGIO_PORTATA[RT].CBR+=1;
      //printf("\nAPPOGGIO_PORTATA CBR per il RT %d  %d \n",RT,APPOGGIO_PORTATA[RT].CBR);
      // scanf("%d",&inutile);
     }
    }
  p=p->NEXT_MACPDU;
  APPOGGIO_PORTATA[RT].GB+=1;
}

 // CALCOLO LE STATISTICHE RILEVANTI PER LA CLASSE BE

 if (OVERFLOW_BE_HAPPENED[RT]==1) hyst_riempimento_BE[RT][CAPIENZA_BUFFER+1]+=1;
 else 
	 if (OVERFLOW_BE_HAPPENED[RT]==0) hyst_riempimento_BE[RT][numero_BE]+=1;

 // ISTOGRAMMA DEI RITARDI DELLE MAC PDU PER TUTTO IL TRAFFICO IP* AL RT
 // DIFFERENZA NS TRAFFICO BE RISPETTO A DELLUOMO

 while (q!=NULL)
   {
    ritardo=t-q->T_GEN;
    ritardo_in_TS=(int)floor(ritardo/DURATA_TS);
    if (ritardo_in_TS >=MAX_RITARDO_TS) hyst_delay_BE[RT][MAX_RITARDO_TS]+=1;
    else hyst_delay_BE[RT][ritardo_in_TS]+=1;
    normalizza_delay_BE[RT]+=1;

   p3=VETTORE_SORGENTI_RT_DL[RT].T3;
   while ((p3->IDENTIFICATIVO)!=(q->SORGENTE)) p3=p3->NEXT_SORG;
   p3->PRIMO_MOMENTO+=ritardo;
   p3->SECONDO_MOMENTO+=pow(ritardo,2);

   if (ritardo>=DELAY_BE[RT].MAX) DELAY_BE[RT].MAX=ritardo;
   if (ritardo<= DELAY_BE[RT].MIN) DELAY_BE[RT].MIN=ritardo;
   
   APPOGGIO_PORTATA[RT].BE+=1;
   q=q->NEXT_MACPDU;
   }

 return;
}


void CALCOLA_STATISTICHE_BASE_TRAMA()
{
int i;

for (i=0;i<NRT;i++) 
{
	hyst_portata_ON_OFF[i][APPOGGIO_PORTATA[i].ON_OFF]+=1; 
	hyst_portata_CBR[i][APPOGGIO_PORTATA[i].CBR]+=1; //Dovrebbe venire un DIRAC
    hyst_portata_GB[i][APPOGGIO_PORTATA[i].GB]+=1;
    hyst_portata_BE[i][APPOGGIO_PORTATA[i].BE]+=1;
        
}
return;
}


// RESTITUISCO IL PUNTATORE ALLE MAC PDU CHE HO TOLTO.
// INOLTRE MODIFICA IL BUFFER CHE GLI E' STATO PASSATO LEVANDO "Tx" MAC PDU
// AD INIZIARE DALLA PRIMA CHE E' STATA INSERITA (FIFO)
BUFFER ACCORCIA_LISTA(BUFFER *p,int Tx,int *num) 
{
 BUFFER temp=*p;
 BUFFER q;
 BUFFER t;
 q=*p;
 int i;
 *num=NUMERO_ELEMENTI_CODA(temp);

 if (*num>0)
 {
  	if (Tx<= *num)
   	{

      	for (i=0;i<Tx-1;i++)  q=q->NEXT_MACPDU;
         if (Tx!=0)
         	{
            
			t=q->NEXT_MACPDU;
                        q->NEXT_MACPDU=NULL;
                        q=t;
			*p=t;
            return (temp);
            }
          else return (NULL);
      }

      else //Tx > (*num)
           {
            p=NULL;
            return (temp);
           }
 }

 else //(*num<=0)
 return(NULL);
}


//SVUOTA I BUFFER UNA VOLTA CHE LE MAC_PDU SONO STATE TRASMESSE
int TRASMISSIONE(double tempo,int time_slot,FILE *risultati)
{
 int RT;
 int trasmessi_GB;
 int trasmessi_BE;
 int numero_GB=0;
 int numero_BE=0;

 int numero_elementi_coda_GB,numero_elementi_coda_BE;

BUFFER p_GB=NULL,q_BE=NULL;

 for (RT=0;RT<NRT;RT++)
 {
  trasmessi_GB=TRASMISSIONE_DL[RT][time_slot].GB;
  //numero_elementi_coda_GB=NUMERO_ELEMENTI_CODA(CODE_GB_RN[RT]);
 
    //printf("\n\nNel TS %d al RT %d vengono trasmesse %d MAC PDU\n",((time_slot+2)%NTS),RT+1,trasmessi_GB);
    //C' uno sfasamento tra la trama e la matrice dei codici
    //printf("\nNumero elementi presenti in coda GB  al RT %d sono %d \n",RT+1,numero_elementi_coda_GB);
    
  //Numero GB  il numero di elementi presenti in coda,trasmessi GB  il numero di elementi da togliere dalla coda
    p_GB=ACCORCIA_LISTA(&CODE_GB_RN[RT],trasmessi_GB,&numero_GB);
 //printf("\nNumero elementi tolti dalla coda GB del RT %d sono %d \n",RT+1,NUMERO_ELEMENTI_CODA(p_GB));
 //printf("\nNumero elementi 'ora' presenti in coda GB al RT %d sono %d \n",RT+1,NUMERO_ELEMENTI_CODA(CODE_GB_RN[RT]));
 
   
  

  trasmessi_BE=TRASMISSIONE_DL[RT][time_slot].BE;
 // numero_elementi_coda_BE=NUMERO_ELEMENTI_CODA(CODE_BE_RN[RT]);
  
 // printf("\n\nNel TS %d al RT %d vengono trasmesse %d MAC PDU\n",((time_slot+2)%NTS),RT+1,trasmessi_BE);
  //printf("\nNumero elementi 'ora' presenti in coda BE al RT %d sono %d \n",RT+1,numero_elementi_coda_BE);
 
 //Numero BE  il numero di elementi presenti in coda,trasmessi Be  il numero di elementi da togliere dalla coda
  q_BE=ACCORCIA_LISTA(&CODE_BE_RN[RT],trasmessi_BE,&numero_BE);
  LUNGHEZZA_CODE_BE[RT]=numero_BE;
  //printf("\nLunghezza della coda = %d \n",LUNGHEZZA_CODE_BE[RT]);
  //printf("\nNumero elementi tolti dalla coda BE del RT %d sono %d \n",RT+1,NUMERO_ELEMENTI_CODA(q_BE));
  //printf("\nNumero elementi presenti in coda BE al RT %d sono %d \n",RT+1,NUMERO_ELEMENTI_CODA(CODE_BE_RN[RT]));

 //ENTRAMBE LE CHIAMATE AD ACCORCIA_LISTA RESTITUISCONO LA PARTE DI BUFFER CHE VIENE TRASMESSA NEL TS CORRENTE
 
 if (((cont_trame+1)>=INIZIO_ANALISI)&&((cont_trame+1)<=FINE_ANALISI))
  CALCOLA_STATISTICHE_BASE_TS(tempo,RT,p_GB,q_BE,numero_GB,numero_BE);
  
  LIBERA_LISTA(p_GB);
  LIBERA_LISTA(q_BE);

 }

return (0);
}



// DEALLOCAZIONE DELLA MEMORIA OCCUPATA DAL VETTORE DELLE SORGENTI DELL'UPLINK
void dealloca_sorgenti_RT_UL()
{
pTIPO_1 pt1_A,pt1_B;
pTIPO_2 pt2_A,pt2_B;
pTIPO_3 pt3_A,pt3_B;
int j;
for (j=0;j<NRT;j++)
    {
    pt1_A=VETTORE_SORGENTI_RT_UL[j].T1;
    pt1_B=pt1_A;
    pt2_A=VETTORE_SORGENTI_RT_UL[j].T2;
    pt2_B=pt2_A;
    pt3_A=VETTORE_SORGENTI_RT_UL[j].T3;
    pt3_B=pt3_A;
    while (pt1_A!=NULL)
          {
          pt1_B=pt1_A->NEXT_SORG;
          free(pt1_A);
          pt1_A=pt1_B;
          }
    VETTORE_SORGENTI_RT_UL[j].T1=NULL;
    while (pt2_A!=NULL)
          {
          pt2_B=pt2_A->NEXT_SORG;
          free(pt2_A);
          pt2_A=pt2_B;
          }
    VETTORE_SORGENTI_RT_UL[j].T2=NULL;
    while (pt3_A!=NULL)
          {
          pt3_B=pt3_A->NEXT_SORG;
          free(pt3_A);
          pt3_A=pt3_B;
          }
    VETTORE_SORGENTI_RT_UL[j].T3=NULL;
    }
return;
}



// DEALLOCAZIONE DELLA MEMORIA OCCUPATA DAL VETTORE DELLE SORGENTI DEL DOWNLINK
void dealloca_sorgenti_RT_DL()
{
pTIPO_1 pt1_A,pt1_B;
pTIPO_2 pt2_A,pt2_B;
pTIPO_3 pt3_A,pt3_B;
int j;
for (j=0;j<NRT;j++)
    {
    pt1_A=VETTORE_SORGENTI_RT_DL[j].T1;
    pt1_B=pt1_A;
    pt2_A=VETTORE_SORGENTI_RT_DL[j].T2;
    pt2_B=pt2_A;
    pt3_A=VETTORE_SORGENTI_RT_DL[j].T3;
    pt3_B=pt3_A;
    while (pt1_A!=NULL)
          {
          pt1_B=pt1_A->NEXT_SORG;
          free(pt1_A);
          pt1_A=pt1_B;
          }
    VETTORE_SORGENTI_RT_DL[j].T1=NULL;
    while (pt2_A!=NULL)
          {
          pt2_B=pt2_A->NEXT_SORG;
          free(pt2_A);
          pt2_A=pt2_B;
          }
    VETTORE_SORGENTI_RT_DL[j].T2=NULL;
    while (pt3_A!=NULL)
          {
          pt3_B=pt3_A->NEXT_SORG;
          free(pt3_A);
          pt3_A=pt3_B;
          }
    VETTORE_SORGENTI_RT_DL[j].T3=NULL;
    }
return;
}

void PRESENTAZIONE()
{
char car;
printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
printf("****************************************************************\n\n\n");
printf("                S I M U L A T O R E   M A C  v1.0\n\n");
printf("     PRIN 2000: SISTEMI OFDM CON APPLICAZIONI ALLE RETI WLAN\n\n");
printf(" UNITA' DI ROMA 1 - UNIVERSITA' DEGLI STUDI DI ROMA \"LA SAPIENZA\"\n\n");
printf("                          Programmatori\n");
printf("               ING.GUERINO GIANCOLA - kubika@libero.it\n");
printf("             ANTONELLA DE LUCA - antonellad@infinito.it\n");
printf("                 FRANCESCO PASSI - f.passi@libero.it\n");
printf("                   ANDREA VITALI - anvit@libero.it\n\n\n");
printf("****************************************************************\n\n\n");
printf("\n                    premi un tasto per cominciare\n\n\n");
//PER USARE TELNET e SSH NON CI DEVONO ESSERE INTERAZIONI UTENTE-MACCHINA.
//car=getchar();


return;
}



////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// INIZIO DEL MAIN
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

int  main()
{



      FILE  *risultati;
      if ((risultati=fopen("risultati.dat","w"))==NULL)
      {
      puts("\nImpossibile aprire il FILE risultati\n");
      exit(1);
      }
    //in questo file vengono scritti i risultati della simulazione


      FILE *MAT_CODICI;
      
      if ((MAT_CODICI=fopen("matricecodici.dat","w"))==NULL)
      {
      puts("\nImpossibile aprire il FILE MAT_CODICI\n");
      exit(1);
      }

      int i=0,j=0,OFF=0,NexT=0;
      int continua,control;    // variabili per i cicli
      int temp,temp1,temp2;          // variabili di appoggio intere
      char ctemp,ctemp1;       // variabili di appoggio carattere
      int flag_UL=0,flag_DL=1;
	//OFF E' UN CONTATORE UTILIZZATO PER LA GESTIONE DELLA MATRICE DEI CODICI
	//PER EVITARE CHE SI VADANO AD OCCUPARE LE RISORSE DEL REQUEST CHANNEL
	//i E' IL CONTATORE DEI RADIO TERMINAL
	//j E' IL CONTATORE DEL NUMERO DI SORGENTI
	//NEXT CONTATORE DI APPOGGIO
	double /*PDU_L_R,*/sum=0;
	//
	//VEDERE COSA E' SUM
 	//
	double MIN = 1000000,MAX = 0,AUS_GB = 0,AUS_BE = 0;
	//VARIABILI PER CALCOLARE I RITARDI E VARIABILI AUSILIARIE
	double t=0,t_DL=0;
	//CONTATORI DEI TEMPI - DANNO IL VALORE IN SECONDI
	int k=0;
	//contatore per la stampa finale
   
	char s_P=0;
	//
	//VEDERE COSA E'
 	//
	//int ausil = 0;

	int m,n;
	//
	int	contatore_TS_in_UL=0;
	int	contatore_TS_in_DL=NTS-2;
	//CONTATORI MA ESPRESSI IN TIME-SLOT
	//double n_tot_GB;
	//double n_tot_BE;
       pTIPO_1 p1;
       pTIPO_2 p2;
       pTIPO_3 p3;
       double varianza; 
       INIZIO_ROUND_ROBIN_GB=1;
       INIZIO_ROUND_ROBIN_BE=1;
       
       int pincopallo=0;
	//int numclosed;
	//RAPPRESENTA I FILES CHE SONO STATI CHIUSI
	

	//SERVE PER INIZIALIZZARE LA FUNZIONE RANDOM
	//ALTERNATIVA 1
        srand((unsigned int)time(NULL)); 
	
	//ALTERNATIVA 2
      /* int stime;
	long ltime;
	ltime=time(NULL);
    stime=(unsigned int)ltime/2;
	srand(stime);*/


         PRESENTAZIONE();

    // INIZIALIZZIAMO I VETTORI CHE RACCOLGONO LE SORGENTI
    inizializza_SORGENTI_DL();
   // inizializza_SORGENTI_UL();
    inizializza_CONTATORI();
   // PRESUPPONE CHE I FILE GIA' ESISTANO
    CREA_MATRICI_SORGENTI();



/*
    /////////////////////////////
    // INSERIMENTO DELLE SORGENTI AI RADIO TERMINALS
    //
    // Attenzione!! Per il momento le sorgenti sono tutte presenti
    // sin dall'inizio della simulazione e non terminano di generare
    // il traffico per tutta la durata della simulazione stessa.
    //
    // Attenzione!! Per il momento introduciamo un set di sorgenti dello stesso
    // tipo. In particolare, in questa versione, introduciamo 'NCLASSI' categorie di
    // sorgenti ogni TIPO
    //
    // Attenzione!! Per il momento il numero e le tipologie delle sorgenti
    // presenti ai radio terminals e al radio node sono completamente scorrelate
    continua = 1;
    printf("\a\nINSERIMENTO DELLE SORGENTI AI RADIO TERMINALS");
    printf("\n\n\nPRIMA SORGENTE\n--------------");
    while (continua>0)
    {
        printf("\nA quale radio terminal appartiene la sorgente? [ 1 - %d ]\n",NRT);
        scanf("%d",&temp);               // temp memorizza IL TERMINALE
        if (temp<=NRT)
        {
           control=0;
           printf("\nDefinizione del tipo di sorgente\n1 - GB ON-OFF\n2 - GB CBR\n3 - BE");
           while (control==0)
           {
           printf("\nDi che tipo e' questa sorgente? [1-2-3]\n");
           scanf("%d",&temp1);           //temp1 memorizza il tipo di sorgente
           if ((temp1!=1)&&(temp1!=2)&&(temp1!=3))
              {
              printf("*** ERRORE *** E' stata indicata una sorgente non valida");
              }
           else control=1;
           }
           // Arrivati a questo punto sono stati indicati correttamente il terminale
           // e il tipo di sorgente
           if (temp1==1)           // sorgente di TIPO 1
           {
           inserisci_sorgente_TIPO1_RT(temp);
           }
           else
           {
                  if(temp1==2)         // sorgente di TIPO 2
                  {
                  inserisci_sorgente_TIPO2_RT(temp);
                  }
                  else                 // sorgente di TIPO 3
                  {
                  inserisci_sorgente_TIPO3_RT(temp);
                  }
           }

           // verifica esistenza nuova sorgente
           printf("\nALTRA SORGENTE? [S/N]");
           scanf("%c%c",&ctemp,&ctemp1);
           if ((ctemp1!='S')&&(ctemp1!='s')) continua = 0;
           else printf("\n\n\nNUOVA SORGENTE\n--------------");
        }
        else printf("*** ERRORE *** Ci sono al massimo %d terminali!! ",NRT);
    }
    CONTA_SORGENTI_RT();
    /// FINE INSERIMENTO SORGENTI AI RADIO TERMINALS
*/




    /////////////////////////////
    // INSERIMENTO DELLE SORGENTI AL RADIO NODE
    //
    // Procedura analoga alla precedente, se non che in questo caso l'indicatore
    // del radio terminal va inteso come IL RADIO TERMINAL CHE QUELLA SORGENTE
    // VUOLE RAGGIUNGERE
    //
 

    /////////////////////////////////////////////////////////////////////////////////////
    //	CODICE DA USARE SE VUOI INTRODURRE I RT E LE SOTTOCLASSI DA TASTIERA
    
    continua=1;
    printf("\a\nINSERIMENTO DELLE SORGENTI AL RADIO NODE\n");
    printf("\n\n\nPRIMA SORGENTE\n--------------");
    while (continua>0)
    {
        printf("\nVerso quale radio terminal la sorgente deve inviare i dati? [ 1 - %d ]\n",NRT);
        scanf("%d",&temp);               // temp memorizza IL TERMINALE
        if (temp<=NRT)
        {
           control=0;
           printf("\nDefinizione del tipo di sorgente\n1 - GB ON-OFF\n2 - GB CBR\n3 - BE");
           while (control==0)
           {
           printf("\nDi che tipo e' questa sorgente? [1-2-3]\n");
           scanf("%d",&temp1);           //temp1 memorizza il tipo di sorgente
           if ((temp1!=1)&&(temp1!=2)&&(temp1!=3))
              {
              printf("*** ERRORE *** E' stata indicata una sorgente non valida");
              }
           else control=1;
           }
           
           // Arrivati a questo punto sono stati indicati correttamente il terminale
           // e il tipo di sorgente
           
if (temp1==1)           // sorgente di TIPO 1
{

    printf("\nScegli il tipo di sorgente ON-OFF:");
    printf("\n1 - DATI AD ALTA VELOCITA'");
    printf("\n2 - DATI A MEDIA VELOCITA'");
    printf("\n3 - DATI A BASSA VELOCITA'");
    printf("\nsottoclasse della sorgente? [ 1 - %d ]   ",NCLASSI);
    scanf("%d",&temp2);
    
   pincopallo=inserisci_sorgente_TIPO1_RN(temp,temp2);
   if (pincopallo!=0)
      	{	
        BANDA_TOTALE+=pincopallo;
        printf("\nRISORSE OCCUPATE CLASSE GB : %4.2lf%\n",(BANDA_TOTALE/(double)CAPACITA_ALLOCABILE_GB)*100);
        }
   else 
   {
   printf("\nsorry,non e' stata allocata la sorgente GB indicata per insufficienza di risorse disponibili");      
   printf("\nRISORSE OCCUPATE CLASSE GB : %4.2lf%\n",(BANDA_TOTALE/(double)CAPACITA_ALLOCABILE_GB)*100);
   }
}

else
{
   if(temp1==2)     // sorgente di TIPO 2
   {
     printf("\nScegli il tipo di sorgente CBR:");
             printf("\n1 - VOCE");
             printf("\n2 - VIDEO ALTA VELOCITA'");
             printf("\n3 - VIDEO BASSA VELOCITA'");
             printf("\nsottoclasse della sorgente? [ 1 - %d ]   ",NCLASSI);
             scanf("%d",&temp2);
             
    pincopallo=inserisci_sorgente_TIPO2_RN(temp,temp2);
    if (pincopallo!=0)
      	{	
        BANDA_TOTALE+=pincopallo;
        
        printf("\nRISORSE OCCUPATE CLASSE GB : %4.2lf%\n",(BANDA_TOTALE/(double)CAPACITA_ALLOCABILE_GB)*100);

        }
   else
      {
      printf("\nsorry,non e' stata allocata la sorgente GB indicata per insufficienza di risorse disponibili\n");           printf("\nRISORSE OCCUPATE CLASSE GB : %4.2lf%\n",(BANDA_TOTALE/(double)CAPACITA_ALLOCABILE_GB)*100);
      }

   }
   else             // sorgente di TIPO 3
   {
     printf("\nScegli il tipo di sorgente BE:");
             printf("\n1 - HTTP");
             printf("\n2 - FTP");
             printf("\n3 - SMTP");
             printf("\nsottoclasse della sorgente? [ 1 - %d ]   ",NCLASSI);
             scanf("%d",&temp2);
    
    inserisci_sorgente_TIPO3_RN(temp,temp2);
   }
}

           // verifica esistenza nuova sorgente
           printf("\nALTRA SORGENTE? [S/N]");
           scanf("%c%c",&ctemp,&ctemp1);
           if ((ctemp1!='S')&&(ctemp1!='s')) continua = 0;
           else printf("\n\n\nNUOVA SORGENTE\n--------------");
        }
        else printf("*** ERRORE *** Ci sono al massimo %d terminali!! ",NRT);
    }
    //////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////
    
      
    
/*    
    //CODICE DA USARE SE VUOI INSERIRE I RT E LE SOTTOCLASSI DA FILE (TELNET E SSH)
    ////////////////////////////////////////////////////////////////////////////////////////////////// 
     FILE  *terminali;
      if ((terminali=fopen("terminali.txt","r"))==NULL)
      {
      puts("\nImpossibile aprire il FILE terminali\n");
      exit(1);
      }
    //da questo file vengono letti i RT, il tipo di sorgente e la sottoclasse scelti

    char fine='0';	
    inutile=0;

    printf("\a\nINSERIMENTO DELLE SORGENTI AL RADIO NODE\n");

    while (fine!=EOF)
    {
        fscanf(terminali,"%d",&temp);               // temp ora memorizza IL TERMINALE
        
        fscanf(terminali,"%d",&temp1);           //temp1 ora memorizza il tipo di sorgente

        fscanf(terminali,"%d",&temp2);  
           // Arrivati a questo punto sono stati indicati correttamente il terminale
           // e il tipo di sorgente

           if (temp1==1)           // sorgente di TIPO 1
           {
           inserisci_sorgente_TIPO1_RN(temp,temp2);
		   printf("\nRT= %d, Sottoclasse= %d\n",temp,temp2);
		   scanf("%d",&inutile);
           }
           else
           {
                  if(temp1==2)         // sorgente di TIPO 2
                  {
                  inserisci_sorgente_TIPO2_RN(temp,temp2);
                  printf("\nRT= %d, Sottoclasse= %d\n",temp,temp2);
		          scanf("%d",&inutile);

                  }
                  else                 // sorgente di TIPO 3
                  {
                  inserisci_sorgente_TIPO3_RN(temp,temp2);
                  printf("\nRT= %d, Sottoclasse= %d\n",temp,temp2);
		          scanf("%d",&inutile);
                  }
           }

           // verifica esistenza nuova sorgente
            fine=fgetc(terminali);

    }
    ////////////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////////
*/
    
    CONTA_SORGENTI_RN();

    /// FINE INSERIMENTO SORGENTI AL RADIO NODE
	
    // PER PRIMA COSA SI DOVREBBE CALCOLARE IL PDU LOSS RATE
	//IN QUESTA PRIMA FASE DELLA SIMULAZIONE NON ESEGUIAMO QUESTO CALCOLO
	//SIMULANDO UNA IDEALE TRASMISSIONE PRIVA DI ERRORI
	//PDU_L_R = calcola_PDU_L_R(FEC,BER);
	//printf("\nIl PDU_L_R  %f \n", PDU_L_R);		
	
	
	//LA PRIMA OPERAZIONE CONSISTE NELL'INIZIALIZZAZIONE DELLA STRUTTURA DEL
	//REQUEST CHANNEL. QUESTA STRUTTURA, IN REALTA', DOVREBBE ESSERE INSERITO
	//ALL'INTERNO DELLA MATRICE DEI CODICI
	//IL REQUEST CHANNEL CONTIENE LE RICHIESTE DEI RADIO TERMINALS
	//VENGONO INDICATE, SOSTANZIALMENTE, LE RISORSE DI CUI AVREBBERO BISOGNO
	//PER TRASMETTERE IN UPLINK LE MAC-PDU CHE LE RELATIVE SORGENTI HANNO GENERATO
	//SIA DI CLASSE GB CHE DI CLASSE BE
	//
	//IL REQUEST CHANNEL OCCUPA LO SPAZIO DI UNA O PIU' MAC-PDU
	//OGNUNA DI QUESTE MAC-PDU E' SEGMENTATA IN MINI-SLOT
	//OGNI MINI-SLOT E' ASSEGNATO AD UN RADIO TERMINAL
	//OGNI MINI-SLOT CONSISTE DI 3 CAMPI
	//LUNG1 - NUMERO DI MACPDU DI CLASSE GB
	//LUNG2 - NUMERO DI MACPDU DI CLASSE BE
	//BUFFER_VUOTI - VARIABILE BOOLEANA CHE VALE 1 SE NON C'E' NULLA DA TRASMETTERE
	//

    inizializzazione_MATRICE_CODICI();
    inizializzazione_REQUEST_CHANNEL();
    inizializzazione_STATO_CODE_AL_RN();
    //inizializzazione_ALLOCATIONAL_CHANNEL();
    //inizializzazione_PAGING_CHANNEL();

    //INIZIALIZZIAMO LE CODE AI BUFFER
    inizializza_BUFFER();
	
    //INIZIALIZZO LE STATISTICHE
    inizializza_STATISTICHE();

    
    inizializza_ASSEGNAZIONE_DL();
    inizializza_TRASMISSIONE_DL();
    inizializza_BANDE_TOTALI_MAC();




    //INIZIALIZZAZIONE DEL TRAFFICO
    
    for (temp=0;temp<NRT;temp++)
    {
printf("\n**************************************************************\n\n");
    // SORGENTI ON-OFF
       // inizializza_sorgenti_TIPO1(VETTORE_SORGENTI_RT_UL,temp);
        inizializza_sorgenti_TIPO1(temp);
    // SORGENTI CBR
        //inizializza_sorgenti_TIPO2(VETTORE_SORGENTI_RT_UL,temp);
        inizializza_sorgenti_TIPO2(temp);
    // SORGENTI BE
       // inizializza_sorgenti_TIPO3(VETTORE_SORGENTI_RT_UL,temp);
        inizializza_sorgenti_TIPO3(temp);
	}


    printf("\n*** FINE INIZIALIZZAZIONI *** \n");


	while (cont_trame<MAX_NUM_TRAME)
	{
	//printf("\n*****************************************\n\n");
	//printf("\n*****************************************\n\n");
	//printf("\n*****************************************\n\n");
    printf("\nLA TRAMA E' LA NUMERO %d E SONO TRASCORSI %lf s\n",cont_trame+1,t_DL);
	//printf("\n*****************************************\n\n");
	//printf("\n*****************************************\n\n");
	//printf("\n*****************************************\n\n");
	
	//TS 0
    //printf ("\nCOMINCIO ORA LA GENERAZIONE DEL TRAFFICO NEL TS 0\n");
	for (i=0;i<NRT;i++) 
	{
    // La generazione del traffico va avanti finche' non finisce il TS corrente:
    // t_DL al momento indica l'inizio del TS corrente
    GENERA_TRAFFICO_TIPO1(flag_DL,i,t_DL+DURATA_TS);
    GENERA_TRAFFICO_TIPO2(flag_DL,i,t_DL+DURATA_TS);
    GENERA_TRAFFICO_TIPO3(flag_DL,i,t_DL+DURATA_TS);
   
   }
		
	fprintf(MAT_CODICI,"\nTRAMA %d\n\n",cont_trame+1);

	for (i=0;i<NRT;i++) ELABORA_STATO_CODE(i,CODE_GB_RN[i],CODE_BE_RN[i],contatore_TS_in_DL);
    //scanf("%d",&inutile);

	ASSEGNA_RISORSE_DL(MAT_CODICI);
	for (i=0;i<NRT;i++)
	{
	ASSEGNAZIONE_DL_PORTATA[i].GB=ASSEGNAZIONE_DL[i].GB;
	ASSEGNAZIONE_DL_PORTATA[i].BE=ASSEGNAZIONE_DL[i].BE;
	}
    riempi_MATRICE_CODICI();
	

    //Calcolo dei ritardi con annessi e connessi
    TRASMISSIONE(t_DL,contatore_TS_in_DL,risultati);
    
	t_DL=t_DL+DURATA_TS;

	contatore_TS_in_DL=(contatore_TS_in_DL+1)%NTS;

    //TS 1
    
    //printf ("\n\nCOMINCIO ORA LA GENERAZIONE DEL TRAFFICO NEL TS 1\n");
	for (i=0;i<NRT;i++) 
	{
     // La generazione del traffico va avanti finche' non finisce il TS corrente:
     // t_DL al momento indica l'inizio del TS corrente
     GENERA_TRAFFICO_TIPO1(flag_DL,i,t_DL+DURATA_TS);
     GENERA_TRAFFICO_TIPO2(flag_DL,i,t_DL+DURATA_TS);
     GENERA_TRAFFICO_TIPO3(flag_DL,i,t_DL+DURATA_TS);
    
     }
   
    // Calcolo dei ritardi con annessi e connessi
    TRASMISSIONE(t_DL,contatore_TS_in_DL,risultati);
    

    t_DL=t_DL+DURATA_TS;

	contatore_TS_in_DL=(contatore_TS_in_DL+1)%NTS;
    

    //TS 2

// stampo la MATRICE_CODICI
/*	for (m=0;m<K;m++)
	{
            fprintf(MAT_CODICI,"\n");
            for (n=0;n<NTS;n++)
            fprintf(MAT_CODICI,"%d ",MATRICE_CODICI[m][n].RT);
            fprintf(MAT_CODICI,"\n");
	}
*/ 
    inizializza_TRASMISSIONE_DL();
	costruisci_TRASMISSIONE_DL();
	//printf("\nHo costruito la trasmissione DL\n");

    // stampo la trasmissione_DL
	fprintf(MAT_CODICI,"\n\n\n");	
	for (m=0;m<NRT;m++)
	{
		fprintf(MAT_CODICI,"\n");
		for (n=0;n<NTS;n++)
                  fprintf(MAT_CODICI," %d & %d   ",TRASMISSIONE_DL[m][n].GB,TRASMISSIONE_DL[m][n].BE);
                fprintf(MAT_CODICI,"\n");
	}
	fprintf(MAT_CODICI,"******************************************************************");

/*
//STAMPO ANCHE QUI LA MATRICE DEI CODICI
  for (m=0;m<K;m++)
	{
		printf("\n");
		for (n=0;n<NTS;n++)
			printf("%d ",MATRICE_CODICI[m][n].RT);
            printf("\n");
	}
	
	printf("\n\n\n\n");	
	
	//STAMPO ANCHE QUI LA TRASMISSIONE******************

  for (m=0;m<NRT;m++)
  {
	printf("\n\n");
	for (n=0;n<NTS;n++)
		printf(" %d & %d    ",TRASMISSIONE_DL[m][n].GB,TRASMISSIONE_DL[m][n].BE);
        printf("\n\n");
  }
*/


    //printf ("\n\nCOMINCIO ORA LA GENERAZIONE DEL TRAFFICO NEL TS 2\n");
    //scanf("%d",&inutile);
    for (i=0;i<NRT;i++) 
    {
     // La generazione del traffico va avanti finche' non finisce il TS corrente:
     // t_DL al momento indica l'inizio del TS corrente
     GENERA_TRAFFICO_TIPO1(flag_DL,i,t_DL+DURATA_TS);
     GENERA_TRAFFICO_TIPO2(flag_DL,i,t_DL+DURATA_TS);
     GENERA_TRAFFICO_TIPO3(flag_DL,i,t_DL+DURATA_TS);
     }

    // Calcolo dei ritardi con annessi e connessi
    TRASMISSIONE(t_DL,contatore_TS_in_DL,risultati);

    t_DL=t_DL+DURATA_TS;

    contatore_TS_in_DL=(contatore_TS_in_DL+1)%NTS;
    

    //TS 3
    
    //printf ("\n\nCOMINCIO ORA LA GENERAZIONE DEL TRAFFICO NEL TS 3\n");

    for (i=0;i<NRT;i++) 
    {
     // La generazione del traffico va avanti finche' non finisce il TS corrente:
     // t_DL al momento indica l'inizio del TS corrente
     GENERA_TRAFFICO_TIPO1(flag_DL,i,t_DL+DURATA_TS);
     GENERA_TRAFFICO_TIPO2(flag_DL,i,t_DL+DURATA_TS);
     GENERA_TRAFFICO_TIPO3(flag_DL,i,t_DL+DURATA_TS);
     } 
   

    // Calcolo dei ritardi con annessi e connessi
    TRASMISSIONE(t_DL,contatore_TS_in_DL,risultati);

     t_DL=t_DL+DURATA_TS;

     contatore_TS_in_DL=(contatore_TS_in_DL+1)%NTS;
    
    //TS 4
    
    //printf ("\n\nCOMINCIO ORA LA GENERAZIONE DEL TRAFFICO NEL TS 4\n");
    for (i=0;i<NRT;i++) 
    {
     // La generazione del traffico va avanti finche' non finisce il TS corrente:
     // t_DL al momento indica l'inizio del TS corrente
     GENERA_TRAFFICO_TIPO1(flag_DL,i,t_DL+DURATA_TS);
     GENERA_TRAFFICO_TIPO2(flag_DL,i,t_DL+DURATA_TS);
     GENERA_TRAFFICO_TIPO3(flag_DL,i,t_DL+DURATA_TS);
     }
    // Calcolo dei ritardi con annessi e connessi
    TRASMISSIONE(t_DL,contatore_TS_in_DL,risultati);

    t_DL=t_DL+DURATA_TS;

    contatore_TS_in_DL=(contatore_TS_in_DL+1)%NTS;
    

    //TS 5
    
    //printf ("\n\nCOMINCIO ORA LA GENERAZIONE DEL TRAFFICO NEL TS 5\n");
    for (i=0;i<NRT;i++) 
    {
     // La generazione del traffico va avanti finche' non finisce il TS corrente:
     // t_DL al momento indica l'inizio del TS corrente
     GENERA_TRAFFICO_TIPO1(flag_DL,i,t_DL+DURATA_TS);
     GENERA_TRAFFICO_TIPO2(flag_DL,i,t_DL+DURATA_TS);
     GENERA_TRAFFICO_TIPO3(flag_DL,i,t_DL+DURATA_TS);
     }
    // Calcolo dei ritardi con annessi e connessi
    TRASMISSIONE(t_DL,contatore_TS_in_DL,risultati);
    t_DL=t_DL+DURATA_TS;
 
    contatore_TS_in_DL=(contatore_TS_in_DL+1)%NTS;
    if (((cont_trame+1)>=INIZIO_ANALISI)&&((cont_trame+1)<=FINE_ANALISI)) CALCOLA_STATISTICHE_BASE_TRAMA();

    inizializza_ASSEGNAZIONE_DL();
    inizializzazione_MATRICE_CODICI();
    inizializzazione_STATO_CODE_AL_RN();

    for (i=0;i<NRT;i++) 
		
	{
		APPOGGIO_PORTATA[i].ON_OFF=0; 
		APPOGGIO_PORTATA[i].CBR=0; 	
        APPOGGIO_PORTATA[i].GB=0;
        APPOGGIO_PORTATA[i].BE=0;
	}
        
        
    cont_trame+=1;
}

fclose(MAT_CODICI);

fprintf(risultati,"\nTRAME CONSIDERATE NELLE STATISTICHE:  # %d -  # %d\n\n",(int)INIZIO_ANALISI,(int)FINE_ANALISI);

fprintf(risultati,"\n****DELAY ON-OFF MAX****\n");
for (i=0;i<NRT;i++) 
{
if ((VETTORE_SORGENTI_RT_DL[i].T1)!=NULL)
  {
  if  (DELAY_ON_OFF[i].MAX==0) fprintf(risultati," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else  fprintf(risultati,"%lf  ",DELAY_ON_OFF[i].MAX);
  }
else fprintf(risultati," ---- "); 
}
fprintf(risultati,"\n\n");

fprintf(risultati,"\n****DELAY ON-OFF MIN****\n");
for (i=0;i<NRT;i++)
{
if ((VETTORE_SORGENTI_RT_DL[i].T1)!=NULL) 
{
  if  (DELAY_ON_OFF[i].MAX==0) fprintf(risultati," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else  fprintf(risultati,"%lf  ",DELAY_ON_OFF[i].MIN);
  }
else fprintf(risultati," ---- "); 
}
fprintf(risultati,"\n\n");

fprintf(risultati,"\n****DELAY CBR MAX****\n");
for (i=0;i<NRT;i++)
{
if ((VETTORE_SORGENTI_RT_DL[i].T2)!=NULL) 

  {
  if  (DELAY_CBR[i].MAX==0) fprintf(risultati," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else  fprintf(risultati,"%lf  ",DELAY_CBR[i].MAX);
  }

else fprintf(risultati," ---- "); 
}
fprintf(risultati,"\n\n");

fprintf(risultati,"\n****DELAY CBR MIN****\n");
for (i=0;i<NRT;i++)
{
if ((VETTORE_SORGENTI_RT_DL[i].T2)!=NULL) 
{
  if  (DELAY_CBR[i].MAX==0) fprintf(risultati," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else  fprintf(risultati,"%lf  ",DELAY_CBR[i].MIN);
  }
else fprintf(risultati," ---- "); 
}

fprintf(risultati,"\n\n");

fprintf(risultati,"\n****DELAY BE MAX****\n");
for (i=0;i<NRT;i++) 
{
if ((VETTORE_SORGENTI_RT_DL[i].T3)!=NULL)  
{
  if  (DELAY_BE[i].MAX==0) fprintf(risultati," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else  fprintf(risultati,"%lf  ",DELAY_BE[i].MAX);
  }
else fprintf(risultati," ---- "); 
}
fprintf(risultati,"\n\n");

fprintf(risultati,"\n****DELAY BE MIN****\n");
for (i=0;i<NRT;i++) 
{
if ((VETTORE_SORGENTI_RT_DL[i].T3)!=NULL)
{
  if  (DELAY_BE[i].MAX==0) fprintf(risultati," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else  fprintf(risultati,"%lf  ",DELAY_BE[i].MIN);
  }
else fprintf(risultati," ---- "); 
} 
fprintf(risultati,"\n\n");


for (i=0;i<NRT;i++)
{
 p1=VETTORE_SORGENTI_RT_DL[i].T1;
 if (p1!=NULL)
 {
 fprintf(risultati,"\nRITARDO MEDIO E VARIANZA PER IL TRAFFICO ON-OFF AL RT %d \n",i+1);
 } 
 if (normalizza_delay_ON_OFF[i]==0) normalizza_delay_ON_OFF[i]=1;
 while (p1!=NULL)
 {
 // printf("\nPRIMO_MOMENTO prima della divisione al RT %d = %15.10lf\n",i+1,p1->PRIMO_MOMENTO);
  p1->PRIMO_MOMENTO=(p1->PRIMO_MOMENTO)/(normalizza_delay_ON_OFF[i]);
 // printf("\nNormalizza_delay_ON_OFF = %d\n",normalizza_delay_ON_OFF[i]);
 // printf("\nPRIMO_MOMENTO= %15.10lf\n",p1->PRIMO_MOMENTO);
  p1->SECONDO_MOMENTO=(p1->SECONDO_MOMENTO)/(normalizza_delay_ON_OFF[i]);
 // printf("\nSECONDO_MOMENTO= %15.10lf\n",p1->SECONDO_MOMENTO);
  varianza=(p1->SECONDO_MOMENTO)-(pow(p1->PRIMO_MOMENTO,2));
 // printf("\nVARIANZA=%15.10lf\n",varianza);
 // scanf("%d",&inutile); 
 
  if  (DELAY_ON_OFF[i].MAX==0) fprintf(risultati," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else  fprintf(risultati,"( %12.11lf , %12.11lf  )",p1->PRIMO_MOMENTO,varianza);
    
  p1=p1->NEXT_SORG;
 }
 fprintf(risultati,"\n\n");
 
p2=VETTORE_SORGENTI_RT_DL[i].T2;
if (p2!=NULL)
{
fprintf(risultati,"\nRITARDO MEDIO E VARIANZA PER IL TRAFFICO CBR AL RT %d \n",i+1); 
}
if (normalizza_delay_CBR[i]==0) normalizza_delay_CBR[i]=1;

 while (p2!=NULL)
 {
  p2->PRIMO_MOMENTO=(p2->PRIMO_MOMENTO)/(normalizza_delay_CBR[i]);
  //printf("\nNormalizza_delay_CBR = %d\n",normalizza_delay_CBR[i]);
  //printf("\nPRIMO_MOMENTO= %15.10lf\n",p2->PRIMO_MOMENTO);
  p2->SECONDO_MOMENTO=(p2->SECONDO_MOMENTO)/(normalizza_delay_CBR[i]);
  varianza=(p2->SECONDO_MOMENTO)-(pow(p2->PRIMO_MOMENTO,2));
  
  
  
  
  if  (DELAY_CBR[i].MAX==0) fprintf(risultati," MAI GENERATO/TRASMESSO TRAFFICO "); 
  else fprintf(risultati,"( %12.11lf , %12.11lf )  ",p2->PRIMO_MOMENTO,varianza);
  
  p2=p2->NEXT_SORG;
 }
 fprintf(risultati,"\n\n");


p3=VETTORE_SORGENTI_RT_DL[i].T3;
if (p3!=NULL)
{
fprintf(risultati,"\nRITARDO MEDIO E VARIANZA PER IL TRAFFICO BE AL RT %d \n",i+1);
}
if (normalizza_delay_BE[i]==0) normalizza_delay_BE[i]=1;

 while (p3!=NULL)
 {
  p3->PRIMO_MOMENTO=(p3->PRIMO_MOMENTO)/(normalizza_delay_BE[i]);
  p3->SECONDO_MOMENTO=(p3->SECONDO_MOMENTO)/(normalizza_delay_BE[i]);
  varianza=(p3->SECONDO_MOMENTO)-(pow(p3->PRIMO_MOMENTO,2));
  
  
  if  (DELAY_BE[i].MAX==0) fprintf(risultati," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else fprintf(risultati,"( %12.11lf , %12.11lf )  ",p3->PRIMO_MOMENTO,varianza);
  
  
  p3=p3->NEXT_SORG;
 }
 fprintf(risultati,"\n\n");
 fprintf(risultati,"\n\n");

}

fprintf(risultati,"\n\n****HYST DELAY BE (la scala dei valori e' 10E-3)****\n");
for (i=0;i<MAX_RITARDO_TS+1;i++)
{
	for (j=0;j<NRT;j++) 
        {
        if (normalizza_delay_BE[j]==0) normalizza_delay_BE[j]=1;
        fprintf(risultati,"%lf  ",(hyst_delay_BE[j][i]/(double)(normalizza_delay_BE[j]))*1000);
        }
	fprintf(risultati,"\n");
        
}
fprintf(risultati,"\n\n");


//NEGLI ISTOGRAMMI VA CONSIDERATO CHE ORA LE STATISTICHE SONO RELATIVE SOLO A UNA FINESTRA
fprintf(risultati,"\nPREPARATORIO A HYST PORTATA ON OFF BASE TRAMA\n");
fprintf(risultati,"\nLa somma dovrebbe essere pari al numero di trame analizzate %d\n",int(FINE_ANALISI-INIZIO_ANALISI+1));
for (i=0;i<NRT;i++)
{
	inutile=0;
	for (j=0;j<NTS*K-SEGNALAZIONE_DL+1;j++) inutile+=hyst_portata_ON_OFF[i][j];
	fprintf(risultati,"\nPer l'RT %d la somma e' %d\n",i+1,inutile);
}

fprintf(risultati,"\n****HYST PORTATA ON OFF SU BASE TRAMA (la scala dei valori e' 10E-3)****\n");
for (i=0;i<NTS*K-SEGNALAZIONE_DL+1;i++)
{
  for (j=0;j<NRT;j++) fprintf(risultati,"%lf  ",(hyst_portata_ON_OFF[j][i]/(double)(FINE_ANALISI-INIZIO_ANALISI+1))*1000);
  fprintf(risultati,"\n");
}


fprintf(risultati,"\nPREPARATORIO A HYST PORTATA CBR BASE TRAMA\n");
fprintf(risultati,"\nLa somma dovrebbe essere pari al numero di trame analizzate %d\n",int(FINE_ANALISI-INIZIO_ANALISI+1));
for (i=0;i<NRT;i++)
{
	inutile=0;
	for (j=0;j<NTS*K-SEGNALAZIONE_DL+1;j++) inutile+=hyst_portata_CBR[i][j];
	fprintf(risultati,"\nPer l'RT %d la somma e' %d\n",i+1,inutile);
}
fprintf(risultati,"\n\n****HYST PORTATA CBR SU BASE TRAMA (la scala dei valori e' 10E-3)****\n");
for (i=0;i<NTS*K-SEGNALAZIONE_DL+1;i++)
{
  for (j=0;j<NRT;j++) fprintf(risultati,"%lf  ",(hyst_portata_CBR[j][i]/(double)(FINE_ANALISI-INIZIO_ANALISI+1))*1000);
  fprintf(risultati,"\n");
}


fprintf(risultati,"\nPREPARATORIO A HYST PORTATA GB BASE TRAMA\n");
fprintf(risultati,"\nLa somma dovrebbe essere pari al numero di trame analizzate %d\n",int(FINE_ANALISI-INIZIO_ANALISI+1));
for (i=0;i<NRT;i++)
{
	inutile=0;
	for (j=0;j<NTS*K-SEGNALAZIONE_DL+1;j++) inutile+=hyst_portata_GB[i][j];
	fprintf(risultati,"\nPer l'RT %d la somma e' %d\n",i+1,inutile);
}
fprintf(risultati,"\n\n****HYST PORTATA GB SU BASE TRAMA (la scala dei valori e' 10E-3)****\n\n");
for (i=0;i<NTS*K-SEGNALAZIONE_DL+1;i++)
{
  for (j=0;j<NRT;j++) fprintf(risultati,"%lf  ",(hyst_portata_GB[j][i]/(double)(FINE_ANALISI-INIZIO_ANALISI+1))*1000);
  fprintf(risultati,"\n");
}

fprintf(risultati,"\nPREPARATORIO A HYST PORTATA BE BASE TRAMA\n");
fprintf(risultati,"\nLa somma dovrebbe essere pari al numero di trame analizzate %d\n",int(FINE_ANALISI-INIZIO_ANALISI+1));
for (i=0;i<NRT;i++)
{
	inutile=0;
	for (j=0;j<NTS*K-SEGNALAZIONE_DL+1;j++) inutile+=hyst_portata_BE[i][j];
	fprintf(risultati,"\nPer l'RT %d la somma e' %d\n",i+1,inutile);
}
fprintf(risultati,"\n\n****HYST PORTATA BE SU BASE TRAMA (la scala dei valori e' 10E-3)****\n\n");
for (i=0;i<NTS*K-SEGNALAZIONE_DL+1;i++)
{
  for (j=0;j<NRT;j++) fprintf(risultati,"%lf  ",(hyst_portata_BE[j][i]/(double)(FINE_ANALISI-INIZIO_ANALISI+1))*1000);
  fprintf(risultati,"\n");
}


//CALCOLATI ALL'INTERNO DELLA riempi_MATRICE_CODICI
fprintf(risultati,"\n\n****HYST CODICI PIU' PROBABILMENTE ASSEGNATI PER Tx GB AL DETERMINATO RT****\n");
for (i=0;i<K;i++)
{	
 for (j=0;j<NRT;j++)	
 {
 if (normalizza_COD_PROBABILE_GB[j]==0) normalizza_COD_PROBABILE_GB[j]=1;
 fprintf(risultati,"%lf  ",hyst_CODICE_PROBABILE_GB[j][i]/(double)(normalizza_COD_PROBABILE_GB[j]));
 }
 fprintf(risultati,"\n");
}
fprintf(risultati,"\n");

fprintf(risultati,"\n\n****HYST CODICI PIU' PROBABILMENTE ASSEGNATI PER Tx BE AL DETERMINATO RT****\n");
for (i=0;i<K;i++)
{ 	
 for (j=0;j<NRT;j++)
 {
 if (normalizza_COD_PROBABILE_BE[j]==0) normalizza_COD_PROBABILE_BE[j]=1;
 fprintf(risultati,"%lf  ",hyst_CODICE_PROBABILE_BE[j][i]/(double)(normalizza_COD_PROBABILE_BE[j]));
 }
 fprintf(risultati,"\n");
 
}
fprintf(risultati,"\n\n");


//NEGLI ISTOGRAMMI VA CONSIDERATO CHE ORA LE STATISTICHE SONO RELATIVE SOLO A UNA FINESTRA

fprintf(risultati,"\nPREPARATORIO A HYST RIEMPIMENTO BUFFER GB BASE TS\n");
fprintf(risultati,"\nLa somma dovrebbe essere pari al numero di TS presenti nelle trame analizzate= %d\n",int(NTS*(FINE_ANALISI-INIZIO_ANALISI+1)));
for (i=0;i<NRT;i++)
{
	inutile=0;
	for (j=0;j<CAPIENZA_BUFFER+2;j++) inutile+=hyst_riempimento_GB[i][j];
	fprintf(risultati,"\nPer l'RT %d la somma e' %d\n",i+1,inutile);
}

fprintf(risultati,"\n****HYST RIEMPIMENTO BUFFER GB SU BASE TS (la scala dei valori e' 10E-3)****\n\n");
for (i=0;i<CAPIENZA_BUFFER+2;i++)
{
for (j=0;j<NRT;j++)
 fprintf(risultati,"%lf  ",(hyst_riempimento_GB[j][i]/(double)(NTS*(FINE_ANALISI-INIZIO_ANALISI+1)))*1000);
 
 fprintf(risultati,"\n");
}


fprintf(risultati,"\nPREPARATORIO A HYST RIEMPIMENTO BUFFER BE BASE TS\n");
fprintf(risultati,"\nLa somma dovrebbe essere pari al numero di TS presenti nelle trame analizzate= %d\n",int(NTS*(FINE_ANALISI-INIZIO_ANALISI+1)));
for (i=0;i<NRT;i++)
{
	inutile=0;
	for (j=0;j<CAPIENZA_BUFFER+2;j++) inutile+=hyst_riempimento_BE[i][j];
	fprintf(risultati,"\nPer l'RT %d la somma e' %d\n",i+1,inutile);
}
fprintf(risultati,"\n\n****HYST RIEMPIMENTO BUFFER BE SU BASE TS (la scala dei valori e' 10E-3)****\n\n");
for (i=0;i<CAPIENZA_BUFFER+2;i++)
{
for (j=0;j<NRT;j++)
 fprintf(risultati,"%lf  ",(hyst_riempimento_BE[j][i]/(double)(NTS*(FINE_ANALISI-INIZIO_ANALISI+1)))*1000);
 
fprintf(risultati,"\n");
}

fprintf(risultati,"\n\n");

fclose(risultati);

// DEALLOCAZIONE DELLE STRUTTURE CHE RACCOLGONO LE SORGENTI
    dealloca_sorgenti_RT_UL();
    dealloca_sorgenti_RT_DL();
    
	
	printf("\n\nFINE SIMULAZIONE\n");
	//scanf("%d",&inutile);

    return 0;
}


